var s3_distributionManager={arrDistributions:null,origin:"",filePath:"",distributionDisplay:"bucket",manageDistributions:function(){
var _1=s3_remoteTreeView.selection.currentIndex;
if(_1==-1){
return;
}
var _2=s3_remoteTreeView.arrRemoteFiles[_1];
var _3=_2.filePath;
this.openDistributionDialog(_3);
},openDistributionDialog:function(_4){
window.openDialog("chrome://s3fox/content/s3DistributionManager.xul","S3 Distribution","chrome,centerscreen,modal",this.arrDistributions,s3_uiManager,_4);
},init:function(){
this.arrDistributions=window.arguments[0];
s3_uiManager=window.arguments[1];
var _5=window.arguments[2];
this.origin=s3_getBucketFromUrl(_5)+".s3.amazonaws.com";
this.filePath=_5;
this.loadDistributions();
},refreshDistributions:function(){
this.listDistributions();
},loadDistributions:function(_6){
if(this.arrDistributions==null){
this.listDistributions(_6);
}else{
this.dataBind(this.arrDistributions);
}
},findByOrigin:function(_7,_8){
var _9=new Array();
if(_7==null){
return null;
}
for(var i=0;i<_7.length;i++){
if(_7[i].origin==_8){
_9.push(i);
}
}
return _9;
},findByDistributionId:function(_b,_c){
for(var i=0;i<_b.length;i++){
if(_b[i].id==_c){
return i;
}
}
return -1;
},setImageStatus:function(_e){
if(s3_get("s3_reloadImg")){
s3_get("s3_reloadImg").hidden=_e;
}
},findByDomain:function(_f,_10){
for(var i=0;i<_f.length;i++){
if(_f[i].domainName==_10){
return i;
}
}
return -1;
},listDistributions:function(_12,_13){
var _14=this;
_14.setImageStatus(false);
s3_uiManager.getActionInstance(this,function(_15){
_14.arrDistributions=_15;
if(!_12){
_14.dataBind(_15);
_14.setImageStatus(true);
}else{
if(_13){
_13.call(_14,_15);
}
}
}).listDistributions();
},toggleDistributions:function(){
if(this.distributionDisplay=="bucket"){
s3_get("btnToggleDistributions").setAttribute("label","Show distributions related to bucket");
this.distributionDisplay="all";
this.dataBind(this.arrDistributions);
}else{
s3_get("btnToggleDistributions").setAttribute("label","Show all distributions");
this.distributionDisplay="bucket";
this.dataBind(this.arrDistributions);
}
},dataBind:function(_16){
if(this.distributionDisplay=="all"){
s3_get("s3_filterBucketLabel").value="Below are distributions for all buckets :";
}else{
s3_get("s3_filterBucketLabel").value="Below are distributions related to bucket \""+s3_getBucketFromUrl(this.filePath)+"\":";
}
var _17=s3_get("s3_distListView");
s3_Utils.removeChildren(s3_get("s3_distListView"));
var _18=true;
for(var i=0;i<_16.length;i++){
var _1a=_16[i];
if(this.origin!=_1a.origin&&this.distributionDisplay=="bucket"){
continue;
}
_18=false;
var _1b=document.createElement("richlistitem");
_1b.setAttribute("class","s3_distributionItem");
_1b.setAttribute("domainName",_1a.domainName);
_1b.setAttribute("status",_1a.status);
_1b.setAttribute("origin",_1a.origin);
_1b.setAttribute("distributionId",_1a.id);
_1b.setAttribute("comment",_1a.comment);
_1b.setAttribute("enabled",_1a.enabled);
_1b.setAttribute("cnames",_1a.cnames);
_1b.setAttribute("filePath",this.filePath);
if(this.origin==_1a.origin){
var _1c=this.filePath;
var _1d="http://"+_1a.domainName;
var url=_1c.replace("/"+s3_getBucketFromUrl(_1c),_1d);
_1b.setAttribute("differentOrigin",false);
var _1f=url;
_1b.setAttribute("resourceUrl",_1f);
_17.appendChild(_1b);
}else{
_1b.setAttribute("differentOrigin",false);
if(this.distributionDisplay=="all"){
_17.appendChild(_1b);
}
}
}
if(_18){
if(s3_get("s3_mesg")){
s3_get("s3_mesg").hidden=false;
s3_get("s3_mesg").value="There are no distributions for this bucket. \nEither create a new distribution or press 'Show all distributions' button";
}
}else{
if(s3_get("s3_mesg")){
s3_get("s3_mesg").hidden=true;
s3_get("s3_mesg").value="";
}
}
},bindDistribution:function(_20,_21){
if(_21==null){
return;
}
_21.setAttribute("enabled",_20.enabled);
_21.setAttribute("status",_20.status);
_21.setAttribute("comment",_20.comment);
_21.setAttribute("cnames",_20.cnames);
var _22=_21.getAttribute("filePath");
var _23="http://"+_20.domainName;
var url=_22.replace("/"+s3_getBucketFromUrl(_22),_23);
var _25=url;
var _26=_20.cnames;
var _27=_26.split(",");
if(s3_Utils.trim(_26)!=""&&_27.length>0){
var _28=new Array();
for(var m=0;m<_27.length;m++){
_23="http://"+_27[m];
url=_22.replace("/"+s3_getBucketFromUrl(_22),_23);
_28.push(url);
}
_25+="\n"+_28.join("\n");
}
_21.setAttribute("resourceUrl",_25);
},onSelect:function(){
var _2a=s3_get("s3_distListView").selectedIndex;
var _2b=s3_get("s3_distListView").getItemAtIndex(_2a);
if(_2b==null){
return;
}
var _2c=_2b.distributionId;
var _2d=this.findByDistributionId(this.arrDistributions,_2c);
if(_2d==-1){
return;
}
if(this.arrDistributions[_2d]==null){
return;
}
var _2e=this.arrDistributions[_2d];
if(!_2e.hasFullData){
this.getDistributionInfo(_2b,_2e.id);
}
},createDistribution:function(){
var _2f=this;
var _30=s3_get("s3_distComment").value;
var _31=s3_get("s3_distEnabled").checked;
var _32=s3_get("s3_distCName").value;
var _33=_32.split(",");
_2f.setImageStatus(false);
s3_uiManager.getActionInstance(this,function(_34){
_2f.arrDistributions.push(_34);
_2f.dataBind(_2f.arrDistributions);
_2f.setImageStatus(true);
}).createDistribution(this.origin,_30,_33,_31);
},getDistributionInfo:function(_35,_36,_37){
var _38=this;
_38.setImageStatus(false);
s3_uiManager.getActionInstance(this,function(_39){
_39.hasFullData=true;
var _3a=_38.findByDistributionId(_38.arrDistributions,_39.id);
if(_3a==-1){
return;
}
_38.arrDistributions[_3a]=_39;
if(_35){
_38.bindDistribution(_39,_35);
}
_38.setImageStatus(true);
if(_37){
_37.call(_38,_39.id);
}
}).getDistributionInfo(_36);
},saveDistribution:function(_3b){
var _3c=this;
_3c.setImageStatus(false);
var _3d=_3c.findByDistributionId(_3c.arrDistributions,_3b);
if(_3d==-1){
return;
}
if(this.arrDistributions[_3d]==null){
return;
}
var _3e=this.arrDistributions[_3d];
var _3f=s3_get("s3_distListView").selectedIndex;
var _40=s3_get("s3_distListView").getItemAtIndex(_3f);
var _41=_40.cnames.split(",");
var _42=_3c.arrDistributions[_3d].eTag;
s3_get("s3_distSaveMessage").hidden=false;
s3_uiManager.getActionInstance(this,function(_43){
_3c.setImageStatus(true);
setTimeout(function(){
s3_get("s3_distSaveMessage").hidden=true;
},20000);
if(_43){
_3e.hasFullData=false;
_3c.getDistributionInfo(_40,_3b);
}
}).setDistribution(_3e.origin,_40.comment,_40.enabled,_3e.callerReference,_3b,_3e.eTag,_41);
},deleteDistribution:function(_44){
var _45=this;
_45.setImageStatus(false);
var _46=_45.findByDistributionId(_45.arrDistributions,_44);
if(_46==-1){
return;
}
var _47=_45.arrDistributions[_46].eTag;
s3_uiManager.getActionInstance(this,function(_48){
if(_48){
var _49=_45.findByDistributionId(_45.arrDistributions,_44);
if(_49==-1){
return;
}
_45.arrDistributions.splice(_49,1);
_45.dataBind(_45.arrDistributions);
}
_45.setImageStatus(true);
}).deleteDistribution(_44,_47);
},showPopup:function(){
s3_Utils.removeChildren(s3_get("s3_distributionPopup"));
var _4a=s3_remoteTreeView.selection.currentIndex;
if(_4a==-1){
return;
}
var _4b=s3_remoteTreeView.arrRemoteFiles[_4a];
var _4c=_4b.filePath;
if(this.arrDistributions==null){
var _4d=this;
var _4e=document.createElement("menuitem");
_4e.setAttribute("label","refreshing...");
s3_get("s3_distributionPopup").appendChild(_4e);
this.listDistributions(true,function(){
_4d.populateMenuItems(_4c);
});
}else{
this.populateMenuItems(_4c);
}
},populateMenuItems:function(_4f){
s3_Utils.removeChildren(s3_get("s3_distributionPopup"));
var _50=this;
var _51=s3_getBucketFromUrl(_4f)+".s3.amazonaws.com";
var _52=this.findByOrigin(this.arrDistributions,_51);
if(_52==null||_52.length==0){
var _53=document.createElement("menuitem");
_53.setAttribute("label","Manage Distributions");
s3_get("s3_distributionPopup").appendChild(_53);
_53.addEventListener("click",function(evt){
_50.openDistributionDialog(_4f);
},false);
return;
}else{
var _55=new Array();
for(var j=0;j<_52.length;j++){
var _57=this.arrDistributions[_52[j]];
var _58="http://"+_57.domainName;
var url=_4f.replace("/"+s3_getBucketFromUrl(_4f),_58);
_55.push(url);
if(_57.cnames==null){
this.getDistributionInfo(null,_57.id,function(_5a){
var _5b=this.findByDistributionId(this.arrDistributions,_5a);
var _5c=this.arrDistributions[_5b].cnames;
if(_5c!=null){
var _5d=_5c.split(",");
if(s3_Utils.trim(_5c)!=""&&_5d.length>0){
for(var m=0;m<_5d.length;m++){
_58="http://"+_5d[m];
url=_4f.replace("/"+s3_getBucketFromUrl(_4f),_58);
_55.push(url);
}
this.addToMenu(_55);
}
}
});
}else{
var _5f=_57.cnames;
if(_5f!=null){
var _60=_5f.split(",");
if(s3_Utils.trim(_5f)!=""&&_60.length>0){
for(var m=0;m<_60.length;m++){
_58="http://"+_60[m];
url=_4f.replace("/"+s3_getBucketFromUrl(_4f),_58);
_55.push(url);
}
this.addToMenu(_55);
}
}
}
}
this.addToMenu(_55);
}
},addToMenu:function(_62){
s3_Utils.removeChildren(s3_get("s3_distributionPopup"));
for(var p=0;p<_62.length;p++){
var url=_62[p];
var _65=document.createElement("menuitem");
_65.setAttribute("label",url);
_65.setAttribute("url",url);
_65.addEventListener("click",function(evt){
var url=this.getAttribute("url");
var _68=Components.classes["@mozilla.org/widget/clipboardhelper;1"].getService(Components.interfaces.nsIClipboardHelper);
_68.copyString(url);
},false);
s3_get("s3_distributionPopup").appendChild(_65);
}
}};
function doOK(){
return true;
}
function doCancel(){
return true;
}

