function s3_TaskUploadSync1(_1,_2,_3,_4,_5){
this.inheritProperties(s3_Task);
this.currentItem;
this.indexDirty;
this.authInfo=_4;
this.localPath=_1;
this.remotePath=_2;
this.skipUnchanged=_3;
this.hasErrors=false;
this.isAutomatic=_5;
this.actionInstance=null;
}
s3_TaskUploadSync1.prototype={abort:function(){
if(this.actionInstance!=null){
this.actionInstance.abortRequest();
}
this.eventManager.fireEvent("Abort",null);
},addToQueue:function(_6,_7){
var _8=_7||{checkedOnServer:false,isExists:false,existHeaders:null,hasHeaders:false,overwrite:false};
if(_6.isDirectory){
_8["type"]="folder";
}else{
_8["type"]="file";
}
var _9=new s3_QItem(_6,this.authInfo,1,_8);
this.processItems.push(_9);
},startProcessing:function(){
this.indexDirty=true;
this.prepareForUploadSync();
var _a=new s3_TaskListInfo(this.taskId,"Preparing for doing PUT(Sync)...","");
s3_taskView.add(_a);
},prepareForUploadSync:function(){
var _b=this.remotePath;
var _c=this.getActionInstance(this.authInfo,function(){
if(_c.hasErrors){
s3_logView.log(_c.errorMessage,"CustomError");
this.eventManager.fireEvent("PrepareUploadError",[this,"Preparing Upload failed"]);
s3_taskView.setError(this.taskId);
return;
}
var _d={};
for(var k=0;k<_c.arrFiles.length;k++){
var _f=_c.arrFiles[k].filePath;
var _10="/"+_f.replace(this.remotePath,"");
_d[_10]=_c.arrFiles[k];
}
this.properties["arrFiles"]=_d;
this.checkSubFolders(this.localPath);
this.deleteExtraRemoteFiles(_d);
this.addToSyncQ();
s3_taskView.remove(this.taskId);
});
_c.listAllFiles(_b,true,null);
this.actionInstance=_c;
},addToSyncQ:function(){
var _11=-s3_syncActionsTreeView.getRowCount();
for(var m=0;m<this.processItems.length;m++){
var _13=this.processItems[m];
var _14=null;
if(_13.properties["isExists"]){
_14={};
}
s3_dump("before adding - "+_13.properties["remotePath"]);
var _15=new s3_actionRow(s3_Utils.localPath(_13.key.parentPath),_13.properties["remotePath"],_13.key.fileName,s3_progStatus.INIT,"upload",_13.key.fileSize,"",_13.key.isDirectory,_14,null,s3_uiManager.getActionInstance());
_15.isSyncActions=true;
s3_syncActionsTreeView.arrActionQ.push(_15);
}
if(!this.isAutomatic){
if(s3_syncActionsTreeView.treeBox){
s3_syncActionsTreeView.treeBox.rowCountChanged(0,_11);
_11=s3_syncActionsTreeView.getRowCount();
s3_syncActionsTreeView.treeBox.rowCountChanged(0,_11);
}
}
s3_syncActionsTreeView.ProcessActionQ("upload");
},deleteExtraRemoteFiles:function(_16){
var _17=null;
for(var _18 in _16){
if(_16[_18].properties==null){
if(_17==null){
_17=new s3_TaskDelete(false,s3_uiManager.authInfo);
}
_17.addToDelete(_16[_18],{filesFetched:false});
}
}
if(_17){
_17.startProcessing();
}
},checkSubFolders:function(_19){
var dir=Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
dir.initWithPath(_19);
if(!dir.exists()||!dir.isDirectory()){
return;
}
var _1b;
var _1c=dir.directoryEntries;
while(_1c.hasMoreElements()){
_1b=false;
var _1d=_1c.getNext().QueryInterface(Components.interfaces.nsILocalFile);
var _1e=new s3_localFileInfo(_1d.path,_1d.leafName,_1d.parent.path,_1d.fileSize,_1d.lastModifiedTime,_1d.isDirectory());
var _1f=_1d.path.replace(this.localPath,"");
_1f=_1f.replace(/\\/gi,"/");
if(this.properties["arrFiles"][_1f]!=null){
s3_dump("exists "+_1f);
this.properties["arrFiles"][_1f].properties={found:true};
_1b=true;
}
var _20={checkedOnServer:true,isExists:_1b,existHeaders:null,hasHeaders:false,overwrite:false};
var _21=this.remotePath+_1f.substr(1);
_21=_21.substr(0,_21.lastIndexOf("/")+1);
_20["remotePath"]=_21;
s3_dump("task upload; Remote Path = "+_21+", "+_20["remotePath"]);
this.addToQueue(_1e,_20);
if(_1e.isDirectory){
this.checkSubFolders(_1e.filePath);
}
}
}};
s3_extend(s3_TaskUploadSync1,s3_Task);

