function s3_TaskDownload(_1,_2,_3){
this.inheritProperties(s3_Task);
this.eventManager.registerEvents(["Abort","DownloadComplete","DownloadFailed","PrepareDownloadFailed","PrepareDownloadComplete"]);
this.hasErrors=false;
this.updateView=_1;
this.authInfo=_2;
this.mainLocalPath=_3;
this.hasErrors=false;
this.mainLocalPath;
this.hashFiles=null;
}
s3_TaskDownload.prototype={abort:function(){
if(this.currentItem!=null){
this.currentItem.actionInstance.abortRequest();
}
this.eventManager.fireEvent("Abort",null);
this.isAborted=true;
},addToQueue:function(_4,_5){
var _6=_5||{filesFetched:false,isExists:false,processed:false};
var _7=new s3_QItem(_4,this.authInfo,1,_6);
this.processItems.push(_7);
},startProcessing:function(){
this.indexDirty=true;
this.processNextItem();
this.addTask("Preparing for Download...","");
},processNextItem:function(){
var _8=this.getNextIndex();
if(_8>=this.processItems.length){
if(this.currentItem!=null){
if(this.hasErrors){
this.setTaskError();
this.eventManager.fireEvent("PrepareDownloadFailed",[this]);
}else{
this.removeTask();
this.eventManager.fireEvent("PrepareDownloadComplete",[this]);
if(this.updateView){
this.getInputFromUser();
}
s3_dump("Download processItem = ");
}
delete this.currentItem;
this.currentItem=null;
}
return;
}
this.currentItem=this.processItems[_8];
try{
this.prepareForDownload(this.currentItem);
}
catch(ex){
this.eventManager.fireEvent("PrepareDownloadFailed",[this,ex]);
}
},prepareForDownload:function(_9){
var _a=this;
if(_9.key.isDirectory){
if(!_9.properties["filesFetched"]){
var _b=_9.key.filePath+"/";
var _c=this.getActionInstance(_9.authInfo,function(){
if(_c.hasErrors){
s3_logView.log(_c.errorMessage,"CustomError");
this.eventManager.fireEvent("PrepareDownloadFailed",[this,"Preparing Download failed"]);
s3_taskView.setError(this.taskId);
return;
}
_9.status=s3_progStatus.PREDOWNLOAD;
var _d=s3_Utils.localPath(this.mainLocalPath+"\\"+_9.key.fileName);
s3_dump("task download; currentLocalPath = "+_d);
_9.properties["isExists"]=this.existsLocal(_d);
_9.properties["filesFetched"]=true;
_9.properties["localPath"]=_d;
var _e=this.currentItem.key.folderPath;
for(var k=0;k<_c.arrFiles.length;k++){
var _10=_c.arrFiles[k].filePath;
var _11=false;
var _12=s3_Utils.localPath(this.mainLocalPath+_10.replace(_e,""));
if(_9.properties["isExists"]){
_11=this.existsLocal(_12);
}
var _13={filesFetched:true,isExists:_11,processed:true};
_13["localPath"]=_12;
s3_dump("task Download; local Path = "+_12);
this.addToQueue(_c.arrFiles[k],_13);
}
this.indexDirty=true;
this.processNextItem();
});
_9.status=s3_progStatus.PROGRESS;
_c.listAllFiles(_b,true,null);
_9.actionInstance=_c;
return;
}else{
_9.status=s3_progStatus.PREDOWNLOAD;
setTimeout(function(){
_a.processNextItem();
},1);
}
}else{
if(!_9.properties["processed"]){
var _14=s3_Utils.localPath(this.mainLocalPath+"\\"+_9.key.fileName);
s3_dump("task download; localpath = "+_14);
_9.properties["isExists"]=this.existsLocal(_14);
_9.properties["localPath"]=_14;
}
_9.status=s3_progStatus.PREDOWNLOAD;
setTimeout(function(){
_a.processNextItem();
},1);
}
this.updateTask("Loading "+_9.key.fileName);
s3_logView.log("Loading to upload - "+_9.key.fileName,"message");
},existsLocal:function(_15){
var _16=Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
_16.initWithPath(_15);
return _16.exists();
},isDirectory:function(_17){
var _18=Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
_18.initWithPath(_17);
return _18.exists()&&_18.isDirectory();
},getParentPath:function(_19){
_19=_19.replace(/\\/gi,"/");
_19=_19.substr(0,_19.lastIndexOf("/")+1);
return s3_Utils.localPath(_19);
},getInputFromUser:function(){
var _1a=-s3_actionTreeView.getRowCount();
s3_fileOpPref.askOption=true;
for(var m=0;m<this.processItems.length;m++){
var _1c=true;
var _1d=this.processItems[m];
var _1e=null;
if(_1d.properties["isExists"]){
if(_1d.key.isDirectory&&s3_fileOpPref.askOption){
alert("Folder '"+_1d.key.fileName+"' already exists in the destination directory. \nIf any of the files have same names, you will be asked if you want to replace those files.");
}
if(s3_fileOpPref.askOption){
window.openDialog("chrome://s3fox/content/s3Overwrite.xul","Overwrite Options","chrome,modal,centerscreen",s3_fileOpPref,_1d.key.fileName,"download");
}
if(s3_fileOpPref.overwriteOption==s3_fileOpPref.SKIP){
s3_fileOpPref.askOption=true;
continue;
}else{
if(s3_fileOpPref.overwriteOption==s3_fileOpPref.SKIP_ALL||s3_fileOpPref.overwriteOption==s3_fileOpPref.CANCEL){
s3_fileOpPref.askOption=false;
continue;
}else{
if(s3_fileOpPref.overwriteOption==s3_fileOpPref.OVERWRITE_DELETE){
s3_fileOpPref.askOption=true;
}else{
if(s3_fileOpPref.overwriteOption==s3_fileOpPref.KEEP_ORIGINAL){
_1c=false;
s3_fileOpPref.askOption=true;
}else{
if(s3_fileOpPref.overwriteOption==s3_fileOpPref.KEEP_ORIGINAL_ALL){
_1c=false;
s3_fileOpPref.askOption=false;
}else{
if(s3_fileOpPref.overwriteOption==s3_fileOpPref.OVERWRITE_DELETE_ALL){
s3_fileOpPref.askOption=false;
}
}
}
}
}
}
_1e={};
}
this.updateTask("Adding to Q "+_1d.key.fileName);
s3_logView.log("Adding to Q - "+_1d.key.fileName,"message");
s3_dump("before adding download - "+_1d.properties["localPath"]);
var _1f=new s3_ActionRow(_1d.key.filePath,s3_Utils.localPath(_1d.properties["localPath"]),_1d.key.fileName,s3_progStatus.INIT,"download",_1d.key.fileSize,"",_1d.key.isDirectory,_1e,_1d.authInfo,(new Date()).getTime()+""+m);
_1f.downloadKeepOriginal=!_1c;
s3_actionTreeView.arrActionQ.push(_1f);
}
if(s3_actionTreeView.treeBox){
s3_actionTreeView.treeBox.rowCountChanged(0,_1a);
_1a=s3_actionTreeView.getRowCount();
s3_actionTreeView.treeBox.rowCountChanged(0,_1a);
}
s3_actionTreeView.ProcessActionQ("download");
}};
s3_extend(s3_TaskDownload,s3_Task);

