function s3_TaskSetACL(_1,_2,_3){
this.inheritProperties(s3_Task);
this.eventManager.registerEvents(["Abort","SetACLCompleteSuccessful","SetACLFailed"]);
this.hasErrors=false;
this.updateView=_1;
this.authInfo=_2;
this.newACL=_3;
}
s3_TaskSetACL.prototype={abort:function(){
if(this.currentItem!=null){
this.currentItem.actionInstance.abortRequest();
}
this.eventManager.fireEvent("Abort",null);
this.isAborted=true;
},addToQueue:function(_4,_5){
var _6=_5||{filesFetched:false};
var _7=_4.filePath;
var _8;
if(_4.isDirectory){
var _9=_4.filePath.indexOf("/",1);
if(_9==-1){
_6["type"]="bucket";
_8=3;
}else{
if(_4.eTag!="d66759af42f282e1ba19144df2d405d0"){
_7+="_$folder$";
_6["type"]="folder";
_8=2;
}
}
}else{
_6["filesFetched"]=true;
_6["type"]="file";
_8=1;
}
var _a=new s3_QItem(_7,this.authInfo,_8,_6);
this.processItems.push(_a);
},startProcessing:function(){
this.processItems.sort(this.sortPriority);
this.indexDirty=true;
this.processNextItem();
this.addTask("Set ACL started...","");
},processNextItem:function(){
var _b=this.getNextIndex();
if(_b>=this.processItems.length){
if(this.currentItem!=null){
if(this.hasErrors){
this.setTaskError();
this.eventManager.fireEvent("SetACLFailed",[this]);
}else{
this.removeTask();
this.eventManager.fireEvent("SetACLCompleteSuccessful",[this]);
}
delete this.currentItem;
this.currentItem=null;
}
return;
}
this.currentItem=this.processItems[_b];
try{
this.setACL(this.currentItem);
}
catch(ex){
this.eventManager.fireEvent("SetACLFailed",[this,ex]);
}
},setACL:function(_c){
var _d=this;
if(_c.properties["type"]!="file"){
if(!_c.properties["filesFetched"]){
var _e=_c.key;
_e=_e.replace("_$folder$","");
var _f=this.getActionInstance(_c.authInfo,function(){
if(_f.hasErrors){
s3_logView.log(_f.errorMessage,"CustomError");
this.eventManager.fireEvent("SetACLFailed",[this,"Preparing to set ACL failed"]);
this.setTaskError();
return;
}
_c.status=s3_progStatus.INIT;
_c.properties["filesFetched"]=true;
for(var k=0;k<_f.arrFiles.length;k++){
if(_f.arrFiles[k].filePath!=_e){
this.addToQueue(_f.arrFiles[k],_c.authInfo,{filesFetched:true});
}
}
this.processItems.sort(this.sortPriority);
this.indexDirty=true;
this.processNextItem();
s3_logView.log("Preparing to set ACL done... ","message");
});
if(_c.properties["type"]=="bucket"){
_e+="/";
}
_c.status=s3_progStatus.PROGRESS;
_f.listAllFiles(_e,true,null);
_c.actionInstance=_f;
this.updateTask("Preparing to set ACL...");
s3_logView.log("Preparing to set ACL... ","message");
return;
}
}
var _f=this.getActionInstance(_c.authInfo,function(_11){
if(_11){
_c.status=s3_progStatus.COMPLETED;
s3_logView.log("Setting ACL successful - "+_c.key,"message");
}else{
_c.status=s3_progStatus.FAILED;
this.hasErrors=true;
s3_logView.log("Setting ACL failed - "+_c.key+", "+_f.errorMessage,"CustomError");
}
setTimeout(function(){
_d.processNextItem();
},200);
});
_c.status=s3_progStatus.PROGRESS;
_f.setAcls(_c.key,this.newACL);
_c.actionInstance=_f;
this.updateTask("Setting ACL for "+_c.key);
s3_logView.log("Setting ACL started - "+_c.key,"message");
}};
s3_extend(s3_TaskSetACL,s3_Task);

