function s3_Action(_1,_2,_3,_4,_5){
this.accessCode=_1;
this.secretKey=_2;
this.isSecure=_3;
this.callbackObj=_4;
this.callbackFunc=_5;
this.arrFiles=new Array();
this.hasErrors=false;
this.statusMessage="";
this.errorMessage="";
this.httpClient=null;
}
s3_Action.prototype={setError:function(_6,_7){
if(_7){
alert(_6);
}
this.hasErrors=true;
this.errorMessage=_6;
},sortHeaders:function(x,y){
if(x.name.toLowerCase()<y.name.toLowerCase()){
return -1;
}else{
if(x.name.toLowerCase()>y.name.toLowerCase()){
return 1;
}
}
return 0;
},getHeaderString:function(_a,_b){
var _c="";
if(_a!=null&&_a.length>0){
_a.sort(this.sortHeaders);
for(var i=0;i<_a.length;i++){
_c+=_a[i].name+":"+_a[i].value+_b;
}
}
return _c;
},getAuthHeader:function(_e,_f){
var _10=s3_encUtils.b64_hmac_sha1(this.secretKey,_e);
return !_f?s3_Utils.stringFormat("AWS {0}:{1}",s3_uiManager.accessCode,_10):s3_Utils.stringFormat("Authorization:AWS {0}:{1}",s3_uiManager.accessCode,_10);
},getBucketFromUrl:function(_11){
var _12=_11.indexOf("/",1);
var _13=_11.length;
if(_12!=-1){
_13=_12;
}
var _14=_11.substring(1,_13);
_14=_14.replace(/\/|\\/gi,"");
return _14;
},abortRequest:function(){
if(this.httpClient!=null){
s3_dump("abort request");
this.httpClient.abort();
}
},getHostUrl:function(_15){
var _16,_17;
if(this.isSecure){
_16="https://";
_17="https://s3.amazonaws.com";
}else{
_16="http://";
_17="http://s3.amazonaws.com";
}
var _18=this.getBucketFromUrl(_15);
var url;
var _1a=new RegExp("/"+_18+"/|/"+_18);
var _1b=_15.replace(_1a,"");
if(_18.toLowerCase()===_18&&_18!=""){
url=_16+_18+".s3.amazonaws.com/"+_1b;
}else{
if(_18!=""){
_18+="/";
}
url=_16+"s3.amazonaws.com/"+_18+_1b;
}
return url;
},getHttpClient:function(){
return new s3_HttpClient(this);
},listAllBuckets:function(){
this.httpClient=this.getHttpClient();
var _1c=new Array();
var _1d="/";
var _1e=(new Date()).toUTCString();
var _1f="";
var _20="";
var _21=s3_Utils.stringFormat("GET\n\n{0}\n{1}\n{2}{3}",_20,_1e,_1f,_1d);
var _22=this.getAuthHeader(_21);
_1c.push(new s3_Header("Authorization",_22));
_1c.push(new s3_Header("Date",_1e));
this.httpClient.doRequest("GET",this.getHostUrl(_1d),"","",_1c,false,function(_23){
if(_23.hasErrors){
this.setError(_23.statusMessage);
}else{
var _24=_23.xmlDoc;
if(_24==null){
this.setError("Error getting response from server.");
if(this.callbackFunc){
this.callbackFunc.call(this.callbackObj);
}
}
var _25=_24.getElementsByTagName("Bucket");
for(var i=0;i<_25.length;i++){
var _27=_25[i].getElementsByTagName("Name")[0].firstChild.nodeValue;
var _28=_25[i].getElementsByTagName("CreationDate")[0].firstChild.nodeValue;
_28=s3_Utils.getDate(_28);
var _29=new s3_remoteFileInfo(_27,0,_28,true,"/"+_27,"/"+_27);
this.arrFiles.push(_29);
}
}
if(this.callbackFunc){
this.callbackFunc.call(this.callbackObj);
}
});
},listFiles:function(_2a,_2b,_2c,_2d,_2e){
if(_2b){
delete this.arrFiles;
this.arrFiles=new Array;
}
var _2f=_2a.substring(0,_2a.indexOf("/",1));
var _30=_2a.substr(_2a.indexOf("/",1)+1);
var _31=_2f+"/";
_30=escape(_30);
var _32="&delimiter=/";
if(_2c){
_32="";
}
if(_2d==null){
_2d="";
}
this.httpClient=this.getHttpClient();
var _33=new Array();
var _34="";
var _35="";
var _36=(new Date()).toUTCString();
var _37=s3_Utils.stringFormat("GET\n\n{0}\n{1}\n{2}{3}",_35,_36,_34,_31);
var _38=this.getAuthHeader(_37);
_33.push(new s3_Header("Authorization",_38));
_33.push(new s3_Header("Date",_36));
var _39=s3_Utils.stringFormat("prefix={0}&marker={1}{2}",_30,_2d,_32);
this.httpClient.doRequest("GET",this.getHostUrl(_2f),_39,null,_33,false,function(_3a){
if(_3a.hasErrors){
this.setError(_3a.statusMessage);
if(this.callbackFunc){
this.callbackFunc.call(this.callbackObj);
}
return;
}
var _3b=_3a.xmlDoc;
this.populateFiles(_3b,_2a);
var _3c=s3_Utils.getTagValue(_3b,"IsTruncated");
if(_3c=="true"){
if(_2e){
_2e.call(this.callbackObj);
}
if(_3b.getElementsByTagName("NextMarker").length>0){
var _3d=s3_Utils.getTagValue(_3b,"NextMarker");
s3_dump("prog callback = "+_3d);
var _3e=this;
_3e.listFiles(_2a,false,false,_3d,_2e);
}else{
var _3f=_3b.getElementsByTagName("Contents");
if(_3f.length>0){
_3d=_3f[_3f.length-1].getElementsByTagName("Key")[0].firstChild.nodeValue;
s3_dump("prog callback = "+_3d);
this.listAllFiles(_2a,false,false,_3d,_2e);
}
}
}else{
if(this.callbackFunc){
this.callbackFunc.call(this.callbackObj);
}
}
});
},listAllFiles:function(_40,_41,_42){
if(_41){
delete this.arrFiles;
this.arrFiles=new Array;
}
var _43=_40.substring(0,_40.indexOf("/",1));
var _44=_40.substr(_40.indexOf("/",1)+1);
var _45=_43+"/";
_44=escape(_44);
var _46="";
if(_42==null){
_42="";
}
this.httpClient=this.getHttpClient();
var _47=new Array();
var _48="";
var _49="";
var _4a=(new Date()).toUTCString();
var _4b=s3_Utils.stringFormat("GET\n\n{0}\n{1}\n{2}{3}",_49,_4a,_48,_45);
var _4c=this.getAuthHeader(_4b);
_47.push(new s3_Header("Authorization",_4c));
_47.push(new s3_Header("Date",_4a));
var _4d=s3_Utils.stringFormat("prefix={0}&marker={1}{2}",_44,_42,_46);
this.httpClient.doRequest("GET",this.getHostUrl(_43),_4d,null,_47,false,function(_4e){
if(_4e.hasErrors){
this.setError(_4e.statusMessage);
if(this.callbackFunc){
this.callbackFunc.call(this.callbackObj);
}
return;
}
var _4f=_4e.xmlDoc;
this.populateFiles(_4f,_40);
var _50=s3_Utils.getTagValue(_4f,"IsTruncated");
if(_50=="true"){
var _51;
if(_4f.getElementsByTagName("NextMarker").length>0){
var _51=s3_Utils.getTagValue(_4f,"NextMarker");
s3_dump("prog callback = "+_51);
this.listAllFiles(_40,false,_51);
}else{
var _52=_4f.getElementsByTagName("Contents");
if(_52.length>0){
_51=_52[_52.length-1].getElementsByTagName("Key")[0].firstChild.nodeValue;
s3_dump("prog callback = "+_51);
this.listAllFiles(_40,false,_51);
}
}
}else{
if(this.callbackFunc){
this.callbackFunc.call(this.callbackObj);
}
}
});
},populateFiles:function(_53,_54){
if(_53==null){
return;
}
var _55=_54.substring(0,_54.indexOf("/",1)+1);
var _56=_54.replace(_55,"");
_55=_55.replace(/\//gi,"");
var _57=_53.getElementsByTagName("Contents");
for(var i=0;i<_57.length;i++){
var _59=_57[i].getElementsByTagName("Key")[0].firstChild.nodeValue;
var _5a=_57[i].getElementsByTagName("LastModified")[0].firstChild.nodeValue;
var _5b=_57[i].getElementsByTagName("Size")[0].firstChild.nodeValue;
var _5c=false;
var _5d=_57[i].getElementsByTagName("ETag")[0].firstChild.nodeValue;
if(_5d!=null){
if(_5d=="\"d66759af42f282e1ba19144df2d405d0\""){
_5c=true;
}
}
if(_59.indexOf("_$folder$")!=-1){
_5c=true;
_59=_59.replace("_$folder$","");
}
_59=_59.replace(_56,"");
var _5e="http://";
var _5f=_5e+_55+".s3.amazonaws.com/"+_56+_59;
_5a=s3_Utils.getDate(_5a);
if(this.fileExists(_59)==-1){
var _60=_59.substr(_59.lastIndexOf("/")+1);
var _61=new s3_remoteFileInfo(_60,_5b,_5a,_5c,_54+_59,_5f);
if(_5d!=null){
_61.eTag=_5d;
}
if(this.filesAsHashTable){
this.arrFiles[_54+_59]=_61;
}else{
this.arrFiles.push(_61);
}
}
}
var _62=_53.getElementsByTagName("CommonPrefixes");
for(var i=0;i<_62.length;i++){
var _59=_62[i].getElementsByTagName("Prefix")[0].firstChild.nodeValue;
_59=_59.replace(_56,"");
_59=_59.substring(0,_59.indexOf("/"));
var _5c=true;
_5a="";
_5b=0;
var _5e="http://";
var _5f=_5e+_55+".s3.amazonaws.com/"+_56+_59;
if(this.fileExists(_59)==-1){
var _61=new s3_remoteFileInfo(_59,_5b,_5a,_5c,_54+_59,_5f);
if(this.filesAsHashTable){
this.arrFiles[_54+_59]=_61;
}else{
this.arrFiles.push(_61);
}
}
}
},fileExists:function(_63){
for(var i=0;i<this.arrFiles.length;i++){
if(this.arrFiles[i].fileName==_63){
return i;
}
}
return -1;
},createBucket:function(_65,_66){
var _67=null;
var _68="/"+_65+"/";
this.httpClient=this.getHttpClient();
var _69=new Array();
var _6a="";
var _6b="";
if(_66!="US"){
_67="<CreateBucketConfiguration>"+"<LocationConstraint>"+_66+"</LocationConstraint>"+"</CreateBucketConfiguration>";
_6b="application/xml; charset=UTF-8";
}
var _6c=(new Date()).toUTCString();
var _6d=s3_Utils.stringFormat("PUT\n\n{0}\n{1}\n{2}{3}",_6b,_6c,_6a,_68);
var _6e=this.getAuthHeader(_6d);
_69.push(new s3_Header("Authorization",_6e));
_69.push(new s3_Header("Date",_6c));
this.httpClient.doRequest("PUT",this.getHostUrl(_68),"",_67,_69,false,function(_6f){
if(_6f.hasErrors){
this.setError(_6f.statusMessage);
}
if(this.callbackFunc){
this.callbackFunc.call(this.callbackObj,!_6f.hasErrors);
}
});
},createRemoteFolder:function(_70,_71){
var _72=null;
var _73=_71+escape(_70);
this.httpClient=this.getHttpClient();
var _74=new Array();
var _75="";
var _76="";
var _77=(new Date()).toUTCString();
var _78=s3_Utils.stringFormat("PUT\n\n{0}\n{1}\n{2}{3}",_76,_77,_75,_73);
var _79=this.getAuthHeader(_78);
_74.push(new s3_Header("Authorization",_79));
_74.push(new s3_Header("Date",_77));
this.httpClient.doRequest("PUT",this.getHostUrl(_73),"",_72,_74,false,function(_7a){
if(_7a.hasErrors){
this.setError(_7a.statusMessage);
}
if(this.callbackFunc){
this.callbackFunc.call(this.callbackObj,!_7a.hasErrors);
}
});
},deleteFile:function(_7b){
var _7c=_7b.indexOf("/",1);
if(_7c==-1){
_7b+="/";
}
var _7d=escape(_7b);
this.httpClient=this.getHttpClient();
var _7e=new Array();
var _7f="";
var _80="";
var _81=(new Date()).toUTCString();
var _82=s3_Utils.stringFormat("DELETE\n\n{0}\n{1}\n{2}{3}",_80,_81,_7f,_7d);
var _83=this.getAuthHeader(_82);
_7e.push(new s3_Header("Authorization",_83));
_7e.push(new s3_Header("Date",_81));
this.httpClient.doRequest("DELETE",this.getHostUrl(_7d),"",null,_7e,false,function(_84){
if(_84.hasErrors){
this.setError(_84.statusMessage);
}
if(this.callbackFunc){
this.callbackFunc.call(this.callbackObj,!_84.hasErrors);
}
});
},getAcls:function(_85){
var _86=_85.indexOf("/",1);
if(_86==-1){
_85+="/";
}
var _87=escape(_85)+"?acl";
this.httpClient=this.getHttpClient();
var _88=new Array();
var _89="";
var _8a="";
var _8b=(new Date()).toUTCString();
var _8c=s3_Utils.stringFormat("GET\n\n{0}\n{1}\n{2}{3}",_8a,_8b,_89,_87);
var _8d=this.getAuthHeader(_8c);
_88.push(new s3_Header("Authorization",_8d));
_88.push(new s3_Header("Date",_8b));
this.httpClient.doRequest("GET",this.getHostUrl(_87),"",null,_88,false,function(_8e){
if(_8e.hasErrors){
this.setError(_8e.statusMessage);
if(this.callbackFunc){
this.callbackFunc.call(this.callbackObj,null);
}
return;
}
var _8f=_8e.xmlDoc;
if(_8f==null){
return null;
}
var _90=_8f.getElementsByTagName("AccessControlList");
var _91=_90[0].getElementsByTagName("Grant");
var _92=new s3_AccessPolicy();
for(var i=0;i<_91.length;i++){
var _94=_91[i].getElementsByTagName("Grantee")[0];
if(_94==null){
return null;
}
var id,_96;
if(_94.getAttribute("xsi:type")=="Group"){
id=_91[i].getElementsByTagName("URI")[0].firstChild.nodeValue;
}else{
if(_94.getAttribute("xsi:type")=="CanonicalUser"){
id=_91[i].getElementsByTagName("ID")[0].firstChild.nodeValue;
_96=_91[i].getElementsByTagName("DisplayName")[0].firstChild.nodeValue;
}
}
var _97=_91[i].getElementsByTagName("Permission")[0].firstChild.nodeValue;
var _98=_91[i].getElementsByTagName("Grantee")[0].getAttribute("xsi:type");
var _99=_92.findGrantee(id);
if(_99!=-1){
var _94=_92.grant[_99];
_94.arrPermissions.push(_97);
}else{
var _94=new s3_Grantee(_98,id,_96);
_94.arrPermissions.push(_97);
_92.addGrantee(_94);
}
}
var _9a=_8f.getElementsByTagName("Owner")[0];
id=_9a.getElementsByTagName("ID")[0].firstChild.nodeValue;
_96=_9a.getElementsByTagName("DisplayName")[0].firstChild.nodeValue;
var _99=_92.findGrantee(id);
if(_99==-1){
var _94=new s3_Grantee("CanonicalUser",id,_96);
_92.addGrantee(_94);
_92.owner=_94;
}else{
_92.owner=_92.grant[_99];
}
if(this.callbackFunc){
this.callbackFunc.call(this.callbackObj,_92);
}
});
},setAcls:function(_9b,acl){
var _9d=_9b.indexOf("/",1);
if(_9d==-1){
_9b+="/";
}
var _9e=escape(_9b)+"?acl";
this.httpClient=this.getHttpClient();
var _9f=new Array();
var _a0="";
var _a1="application/xml; charset=UTF-8";
var _a2=(new Date()).toUTCString();
var _a3=s3_Utils.stringFormat("PUT\n\n{0}\n{1}\n{2}{3}",_a1,_a2,_a0,_9e);
var _a4=this.getAuthHeader(_a3);
_9f.push(new s3_Header("Authorization",_a4));
_9f.push(new s3_Header("Date",_a2));
this.httpClient.doRequest("PUT",this.getHostUrl(_9e),"",acl,_9f,false,function(_a5){
if(_a5.hasErrors){
this.setError(_a5.statusMessage);
}
if(this.callbackFunc){
this.callbackFunc.call(this.callbackObj,!_a5.hasErrors);
}
});
},getHeaderInfo:function(_a6){
var _a7=_a6.indexOf("/",1);
if(_a7==-1){
_a6+="/";
}
var _a8=escape(_a6);
this.httpClient=this.getHttpClient();
var _a9=new Array();
var _aa="";
var _ab="";
var _ac=(new Date()).toUTCString();
var _ad=s3_Utils.stringFormat("HEAD\n\n{0}\n{1}\n{2}{3}",_ab,_ac,_aa,_a8);
var _ae=this.getAuthHeader(_ad);
_a9.push(new s3_Header("Authorization",_ae));
_a9.push(new s3_Header("Date",_ac));
this.httpClient.doRequest("HEAD",this.getHostUrl(_a8),"",null,_a9,false,function(_af){
if(_af.hasErrors){
this.setError(_af.statusMessage);
}
if(this.callbackFunc){
this.callbackFunc.call(this.callbackObj,!_af.hasErrors,_af.responseHeaders);
}
});
},getAclForUpload:function(_b0){
var _b1=_b0.indexOf("/",1);
if(_b1==-1){
_b0+="/";
}
var _b2=escape(_b0)+"?acl";
this.httpClient=this.getHttpClient();
var _b3=new Array();
var _b4="";
var _b5="";
var _b6=(new Date()).toUTCString();
var _b7=s3_Utils.stringFormat("GET\n\n{0}\n{1}\n{2}{3}",_b5,_b6,_b4,_b2);
var _b8=this.getAuthHeader(_b7);
_b3.push(new s3_Header("Authorization",_b8));
_b3.push(new s3_Header("Date",_b6));
this.httpClient.doRequest("GET",this.getHostUrl(_b2),"",null,_b3,false,function(_b9){
if(_b9.hasErrors){
this.setError(_b9.statusMessage);
if(this.callbackFunc){
this.callbackFunc.call(this.callbackObj,null);
}
return;
}
var _ba=_b9.xmlDoc;
if(_ba==null){
return null;
}
var _bb=new XMLSerializer();
var _bc=_bb.serializeToString(_ba);
if(this.callbackFunc){
this.callbackFunc.call(this.callbackObj,_bc);
}
});
},uploadObject:function(_bd,_be,_bf,_c0,_c1,_c2){
var _c3=_c0+_be;
var _c4=s3_Utils.localPath(_bf+"\\"+_be);
var _c5=Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
_c5.initWithPath(_c4);
if(!_c5.exists()){
this.setError("File does not exist");
if(this.callbackFunc){
this.callbackFunc.call(this.callbackObj,false);
}
}
if(_c5.isDirectory()){
if(_c0!="/"){
_c3+="_$folder$";
}
}
var _c6=function(_c7){
var _c8=_be.substring(_be.lastIndexOf(".")+1,_be.length);
var _c9=Components.classes["@mozilla.org/mime;1"].getService(Components.interfaces.nsIMIMEService);
try{
strMime=_c9.getTypeFromExtension(_c8);
}
catch(ex){
strMime="application/x-unknown-content-type";
}
this.httpClient=this.getHttpClient();
var _ca=[{"name":"x-amz-meta-s3fox-modifiedtime","value":_c5.lastModifiedTime},{"name":"x-amz-meta-s3fox-filesize","value":_c5.fileSize}];
var _cb=this.getHeaderString(_ca,"\n");
var _cc=strMime;
var _cd=(new Date()).toUTCString();
var _ce=s3_Utils.stringFormat("PUT\n\n{0}\n{1}\n{2}{3}",_cc,_cd,_cb,escape(_c3));
s3_dump("s3_Action; upload Func; strToSign = "+_ce);
var _cf=this.getAuthHeader(_ce);
_ca.push(new s3_Header("Content-Type",_cc));
_ca.push(new s3_Header("Authorization",_cf));
_ca.push(new s3_Header("Date",_cd));
s3_dump("s3_Actions; upload object; resLoc = "+_c3+", localFilePath = "+_c4);
this.httpClient.uploadFile("PUT",this.getHostUrl(escape(_c3)),_c4,_ca,function(_d0){
if(_d0.hasErrors){
this.setError(_d0.statusMessage);
if(this.callbackFunc){
this.callbackFunc.call(this.callbackObj,{isSuccess:!_d0.hasErrors,actionId:_bd,statusMessage:_d0.statusMessage});
}
}else{
if(_c1){
var act=new s3_Action(this.accessCode,this.secretKey,this.isSecure,this,function(_d2){
if(!_d2){
this.setError("Error setting ACL");
}
if(this.callbackFunc){
this.callbackFunc.call(this.callbackObj,{isSuccess:_d2,actionId:_bd,statusMessage:this.errorMessage});
}
});
act.setAcls(_c3,_c7);
}else{
if(this.callbackFunc){
this.callbackFunc.call(this.callbackObj,{isSuccess:!_d0.hasErrors,actionId:_bd,statusMessage:""});
}
}
}
},function(_d3){
if(_c2){
_c2.call(this.callbackObj,{isSuccess:true,actionId:_bd,progress:_d3,statusMessage:""});
}
});
};
if(_c1){
var act=new s3_Action(this.accessCode,this.secretKey,this.isSecure,this,function(_d5){
if(_d5==null){
this.setError("Error getting ACL for the project");
if(this.callbackFunc){
this.callbackFunc.call(this.callbackObj,{isSuccess:false,actionId:_bd,statusMessage:"Error getting ACL for the project"});
}
}else{
_c6.call(this,_d5);
}
});
act.getAclForUpload(_c3);
}else{
_c6.call(this);
}
},downloadObject:function(_d6,_d7,_d8,_d9,_da,_db,_dc,_dd,_de){
try{
if(_dc){
var _df=Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
var _e0=s3_Utils.localPath(_d9);
_df.initWithPath(_e0);
if(!_df.exists()||!_df.isDirectory()){
_df.create(Components.interfaces.nsIFile.DIRECTORY_TYPE,509);
}
if(this.callbackFunc){
this.callbackFunc.call(this.callbackObj,{isSuccess:true,actionId:_d6,statusMessage:""});
}
}else{
var _e1=escape(_d8);
this.httpClient=this.getHttpClient();
var _e2=[];
var _e3="";
var _e4="";
var _e5=(new Date()).toUTCString();
var _e6=s3_Utils.stringFormat("GET\n\n{0}\n{1}\n{2}{3}",_e4,_e5,_e3,_e1);
s3_dump("s3_Action; download Func; strToSign = "+_e6);
var _e7=this.getAuthHeader(_e6);
_e2.push(new s3_Header("Authorization",_e7));
_e2.push(new s3_Header("Date",_e5));
var _e8=this.getHeaderString(_e2,"\r\n");
this.httpClient.downloadFile(_d7,_d9,_db,_da,this.getHostUrl(_e1),_e8,function(_e9){
if(_e9.hasErrors){
this.setError(_e9.statusMessage);
if(this.callbackFunc){
this.callbackFunc.call(this.callbackObj,{isSuccess:!_e9.hasErrors,actionId:_d6,statusMessage:_e9.statusMessage});
}
}else{
if(this.callbackFunc){
this.callbackFunc.call(this.callbackObj,{isSuccess:!_e9.hasErrors,actionId:_d6,statusMessage:""});
}
}
},function(_ea){
if(_de){
_de.call(this.callbackObj,{isSuccess:true,actionId:_d6,progress:_ea,statusMessage:""});
}
});
}
}
catch(ex){
if(this.callbackFunc){
this.callbackFunc.call(this.callbackObj,{isSuccess:false,actionId:_d6,statusMessage:ex});
}
}
}};
function s3_Actions(_eb,_ec,_ed,_ee,_ef){
this.accessCode=_eb;
this.secretKey=_ec;
this.isSecure=_ed;
this.arrFiles=new Array;
this.requestType="";
this.remotePath="";
this.existIndex=-1;
this.filePath="";
this.isError=0;
this.errorMesg="";
this.actStatus=0;
this.objHttp=new s3_xhttp(_eb,_ec,_ed);
this.responseStatus="";
this.isListFiles="recursive";
this.ticket="";
this.isDisplay=true;
this.strAcp="";
this.headerInfo=new Array;
this.callbackObj=_ee;
this.callbackFunc=_ef;
}
s3_Actions.prototype={setError:function(_f0,_f1){
if(_f1){
alert(_f0);
}
this.hasErrors=true;
this.errorMesg=_f0;
},listAllBuckets:function(_f2){
var _f3=_f2.xmlDoc;
var _f4=_f3.getElementsByTagName("Bucket");
for(var i=0;i<_f4.length;i++){
var _f6=_f4[i].getElementsByTagName("Name")[0].firstChild.nodeValue;
var _f7=_f4[i].getElementsByTagName("CreationDate")[0].firstChild.nodeValue;
_f7=s3_Utils.getDate(_f7);
var _f8=new s3_remoteFileInfo(_f6,0,_f7,true,"/"+_f6,"/"+_f6);
this.arrFiles.push(_f8);
}
if(this.isDisplay){
s3_remoteTreeView.displayFiles(this);
}
},listObjects:function(_f9){
var _fa=_f9.xmlDoc;
if(_fa==null){
s3_remoteTreeView.displayFiles(this);
return;
}
var _fb=this.remotePath.substring(0,this.remotePath.indexOf("/",1)+1);
var _fc=this.remotePath.replace(_fb,"");
_fb=_fb.replace(/\//gi,"");
var _fd=_fa.getElementsByTagName("Contents");
for(var i=0;i<_fd.length;i++){
var _ff=_fd[i].getElementsByTagName("Key")[0].firstChild.nodeValue;
var _100=_fd[i].getElementsByTagName("LastModified")[0].firstChild.nodeValue;
var _101=_fd[i].getElementsByTagName("Size")[0].firstChild.nodeValue;
var _102=false;
var eTag=_fd[i].getElementsByTagName("ETag")[0].firstChild.nodeValue;
if(eTag!=null){
if(eTag=="\"d66759af42f282e1ba19144df2d405d0\""){
_102=true;
}
}
if(_ff.indexOf("_$folder$")!=-1){
_102=true;
_ff=_ff.replace("_$folder$","");
}
_ff=_ff.replace(_fc,"");
var _104="http://";
var _105=_104+_fb+".s3.amazonaws.com/"+_fc+_ff;
_100=s3_Utils.getDate(_100);
if(this.fileExists(_ff)==-1){
var _106=new s3_remoteFileInfo(_ff,_101,_100,_102,this.remotePath+_ff,_105);
if(eTag!=null){
_106.eTag=eTag;
}
this.arrFiles.push(_106);
}
}
var _107=_fa.getElementsByTagName("CommonPrefixes");
for(var i=0;i<_107.length;i++){
var _ff=_107[i].getElementsByTagName("Prefix")[0].firstChild.nodeValue;
_ff=_ff.replace(_fc,"");
_ff=_ff.substring(0,_ff.indexOf("/"));
var _102=true;
_100="";
_101=0;
var _104="http://";
var _105=_104+_fb+".s3.amazonaws.com/"+_fc+_ff;
if(this.fileExists(_ff)==-1){
var _106=new s3_remoteFileInfo(_ff,_101,_100,_102,this.remotePath+_ff,_105);
this.arrFiles.push(_106);
}
}
var _108=_fa.getElementsByTagName("IsTruncated")[0].firstChild.nodeValue;
if(_108=="true"){
if(_fa.getElementsByTagName("NextMarker").length>0){
var _109=_fa.getElementsByTagName("NextMarker")[0].firstChild.nodeValue;
this.listFiles(this.remotePath,false,false,_109);
}
}else{
if(this.isDisplay){
s3_remoteTreeView.displayFiles(this);
}
}
},listFiles:function(path,_10b,_10c,_10d){
if(_10b){
delete this.arrFiles;
this.arrFiles=new Array;
}
this.remotePath=path;
if(path=="/"){
this.objHttp.doRequest("GET",path,"",null,null,this,false,"listBuckets",false);
}else{
var _10e=path.substring(0,path.indexOf("/",1));
var _10f=path.substr(path.indexOf("/",1)+1);
_10f=encodeURI(_10f);
var _110="&delimiter=/";
if(_10c){
_110="";
}
if(_10d==null){
_10d="";
}
this.objHttp.doRequest("GET",_10e,"prefix="+_10f+_110+"&marker="+_10d,null,null,this,true,"listObjects",false);
}
},getRemoteFilesList:function(_111){
this.isDisplay=false;
this.listFiles(_111,true,true);
},getHeaderInfo:function(_112){
var _113=this.objHttp.doRequest("HEAD",_112,"",null,"",this,true,"getHeaderInfo",false);
var _114=_113.strHeaders;
var _115=_114.split("\n");
s3_dump("all headers = "+_114);
for(var i=0;i<_115.length;i++){
var _117=_115[i];
if(s3_Utils.trim(_117)!=""){
this.headerInfo[s3_Utils.trim(_117.split(":")[0])]=s3_Utils.trim(_117.split(":")[1]);
}
}
},onResponseComplete:function(_118){
if(_118.hasErrors!=null&&_118.hasErrors){
alert(_118.eMesg);
this.isError=1;
this.uploadStatus=this.FAILED;
if(_118.requestType=="listBuckets"){
s3_uiManager.loginStatus=s3_progStatus.LOGOUT;
}
return;
}
if(_118.requestType=="listBuckets"){
s3_uiManager.status=1;
s3_uiManager.loginStatus=s3_progStatus.LOGIN;
this.listAllBuckets(_118);
}else{
if(_118.requestType=="listObjects"){
this.listObjects(_118);
}else{
if(_118.requestType=="createFolder"){
this.onCompleteAddFolder(_118);
}
}
}
},createRemoteFolder:function(_119,_11a,_11b){
var _11c=null;
if(_11b!="US"){
_11c="<CreateBucketConfiguration>"+"<LocationConstraint>"+_11b+"</LocationConstraint>"+"</CreateBucketConfiguration>";
}
this.objHttp.doRequest("PUT",_11a+_119,"",null,_11c,this,false,"createFolder",false);
},onCompleteFileUpload:function(_11d){
this.uploadStatus=this.COMPLETE;
if(this.existIndex!=-1){
this.objHttp.doRequest("PUT",this.filePath,"acl",null,this.strAcp,this,true,"setAcl",true);
}
},onCompleteFileDownload:function(_11e){
this.downloadStatus=this.COMPLETE;
},onCompleteAddFolder:function(_11f){
setTimeout(function(){
s3_remoteTreeView.refreshFolder();
},1);
},deleteFile:function(path){
this.objHttp.doRequest("DELETE",path,"",null,"",this,true,"deleteFile",false);
},setAcls:function(_121,_122){
return this.objHttp.doRequest("PUT",_121,"acl",null,_122,this,true,"setAcl",true);
},getAcls:function(_123){
var _124=this.objHttp.doRequest("GET",_123,"acl",null,"",this,true,"getAcl",true);
var _125=_124.xmlDoc;
if(_125==null){
return null;
}
var _126=_125.getElementsByTagName("AccessControlList");
var _127=_126[0].getElementsByTagName("Grant");
var _128=new s3_accessPolicy();
for(var i=0;i<_127.length;i++){
var _12a=_127[i].getElementsByTagName("Grantee")[0];
if(_12a==null){
return null;
}
var id,name;
if(_12a.getAttribute("xsi:type")=="Group"){
id=_127[i].getElementsByTagName("URI")[0].firstChild.nodeValue;
}else{
if(_12a.getAttribute("xsi:type")=="CanonicalUser"){
id=_127[i].getElementsByTagName("ID")[0].firstChild.nodeValue;
name=_127[i].getElementsByTagName("DisplayName")[0].firstChild.nodeValue;
}
}
var _12d=_127[i].getElementsByTagName("Permission")[0].firstChild.nodeValue;
var type=_127[i].getElementsByTagName("Grantee")[0].getAttribute("xsi:type");
var _12f=_128.findGrantee(id);
if(_12f!=-1){
var _12a=_128.grant[_12f];
_12a.arrPermissions.push(_12d);
}else{
var _12a=new s3_grantee(type,id,name);
_12a.arrPermissions.push(_12d);
_128.addGrantee(_12a);
}
}
var _130=_125.getElementsByTagName("Owner")[0];
id=_130.getElementsByTagName("ID")[0].firstChild.nodeValue;
name=_130.getElementsByTagName("DisplayName")[0].firstChild.nodeValue;
var _12f=_128.findGrantee(id);
if(_12f==-1){
var _12a=new s3_grantee("CanonicalUser",id,name);
_128.addGrantee(_12a);
_128.owner=_12a;
}else{
_128.owner=_128.grant[_12f];
}
return _128;
},uploadObject:function(_131){
var _132=this;
try{
var _133="@mozilla.org/io/string-input-stream;1";
var _134="@mozilla.org/io/multiplex-input-stream;1";
var _135="@mozilla.org/network/file-input-stream;1";
var _136="@mozilla.org/network/buffered-input-stream;1";
var _137=Components.interfaces.nsIStringInputStream;
var _138=Components.interfaces.nsIMultiplexInputStream;
var _139=Components.interfaces.nsIFileInputStream;
var _13a=Components.interfaces.nsIBufferedInputStream;
var _132=this;
var _13b=_131.fileName;
var _13c=_131.fromPath;
var _13d=_131.toPath;
var _13e=Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
_13e.initWithPath(_13c);
_13e.append(_13b);
s3_dump("ADFDe "+_13d+"/ "+_13b);
if(!_13e.exists()){
throw _13b+" "+s3_Utils.getPropertyString("filenotexists");
}
var buf=Components.classes[_133].createInstance(_137);
buf.setData("",0);
if(_13e.isDirectory()){
if(_13d!="/"){
_13b+="_$folder$";
}else{
var _140="<CreateBucketConfiguration>"+"<LocationConstraint>EU</LocationConstraint>"+"</CreateBucketConfiguration>";
buf.setData(_140,_140.length);
}
}
if(_131.objFileInfo!=null){
var tAct=new s3_xhttp(this.accessCode,this.secretKey,this.isSecure);
var _142=tAct.doRequest("GET",_13d+_13b,"acl",null,"",this,true,"getAcl",true);
var _143=_13d+_13b;
var _144=_142.xmlDoc;
var _145=new XMLSerializer();
_131.objFileInfo.strAcp=_145.serializeToString(_144);
}
var _146=Components.classes[_136].createInstance(_13a);
var _147=" ";
if(!_13e.isDirectory()){
var fin=Components.classes[_135].createInstance(_139);
fin.init(_13e,1,0,false);
_146.init(fin,9000000);
var _149=_13b.substring(_13b.lastIndexOf(".")+1,_13b.length);
var mime=Components.classes["@mozilla.org/mime;1"].getService(Components.interfaces.nsIMIMEService);
try{
_147=mime.getTypeFromExtension(_149);
}
catch(ex){
_147="application/x-unknown-content-type";
}
}else{
var hsis=Components.classes[_133].createInstance(_137);
hsis.setData("",0);
_146.init(hsis,9000000);
}
_13d+=_13b;
var _14c=_13d;
var verb="PUT";
var _14e="";
var _14f=[{"name":"x-amz-meta-s3fox-modifiedtime","value":_13e.lastModifiedTime},{"name":"x-amz-meta-s3fox-filesize","value":_13e.fileSize}];
var _150=this.objHttp.getObject();
var url=s3_getHostUrl(verb,_14c,"");
_150.open(verb,url,true);
if(_14f instanceof Array){
_14f.sort(this.objHttp.metadataSort);
for(var i=0;i<_14f.length;i++){
_14e+=_14f[i].name.toLowerCase()+":"+_14f[i].value;
_14e+="\n";
_150.setRequestHeader(_14f[i].name,_14f[i].value);
}
}
if(!_13e.isDirectory()){
var _153=_146.available();
}else{
var _153=0;
}
s3_setSignature(_150,verb,_14c,"",_14e,null,_147);
if(_153==0){
_150.setRequestHeader("Content-Length",0);
_150.send(null);
}else{
_150.setRequestHeader("Content-Length",_153);
_150.send(_146);
}
_131.status=s3_progStatus.PROGRESS;
var _154=setInterval(function(){
var _155=_153-_146.available();
_131.intProgress=Math.round(_155/_153*100);
var _156=(_131.isSyncActions)?s3_syncActionsTreeView:s3_actionTreeView;
_156.InvalidateTree(_131.index);
if(_131.intProgress<100){
_131.lastUpdated=(new Date()).getTime();
}
},200);
_150.onreadystatechange=function(){
if(_150.readyState!=4){
return;
}else{
try{
if(_150.status>=200&&_150.status<300){
buf.close();
if(fin!=null){
fin.close();
}
clearInterval(_154);
_146.close();
_131.lastUpdated=(new Date()).getTime();
_131.intProgress=100;
_131.status=s3_progStatus.COMPLETED;
if(_131.objFileInfo!=null){
var tAct=new s3_xhttp(_132.accessCode,_132.secretKey,_132.isSecure);
tAct.doRequest("PUT",_143,"acl",null,_131.objFileInfo.strAcp,_132,true,"setAcl",true);
}
var _158=(_131.isSyncActions)?"s3_uploadSync":"s3_upload";
s3_fireEvent(_158,document,{"tActionRow":_131,"isError":0});
}else{
var _159=_150.responseXML;
var _15a=_159.getElementsByTagName("Message")[0].firstChild.nodeValue;
s3_dump("Response = "+_150.responseText);
throw "Problem with connection! "+_15a;
}
}
catch(ex){
_132.isError=1;
_131.lastUpdated=(new Date()).getTime();
clearInterval(_154);
_131.intProgress=0;
_131.status=s3_progStatus.FAILED;
var _158=(_131.isSyncActions)?"s3_uploadSync":"s3_upload";
s3_fireEvent(_158,document,{"tActionRow":_131,"isError":1,"errorMesg":ex});
}
}
};
}
catch(ex){
throw ex;
}
},fileExists:function(_15b){
var _15c=-1;
for(var i=0;i<this.arrFiles.length;i++){
if(this.arrFiles[i].fileName==_15b){
_15c=i;
break;
}
}
return _15c;
},downloadFileObject:function(_15e){
try{
if(_15e.isDirectory){
var file=Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
var _160=s3_Utils.localPath(_15e.toPath);
file.initWithPath(_160);
if(!file.exists()||!file.isDirectory()){
file.create(Components.interfaces.nsIFile.DIRECTORY_TYPE,509);
}
_15e.lastUpdated=(new Date()).getTime();
_15e.intProgress=100;
_15e.status=s3_progStatus.COMPLETED;
var _161=(_15e.isSyncActions)?"s3_downloadSync":"s3_download";
s3_fireEvent(_161,document,{"tActionRow":_15e,"isError":0});
var _162=(_15e.isSyncActions)?s3_syncActionsTreeView:s3_actionTreeView;
_162.InvalidateTree(_15e.index);
}else{
_15e.status=s3_progStatus.PROGRESS;
var _163=_15e.fromPath;
var url=s3_getHostUrl("GET",_163,"");
var _165=s3_setSignature(null,"GET",_163,"","",null,"");
s3_dump(s3_uiManager.accessCode+", New = "+_165);
this.objHttp.downloadFile(_15e,url,this,"fileDownload",_165);
}
}
catch(ex){
alert(ex);
}
},listFilesNew:function(path,_167,_168,_169,_16a){
if(_167){
delete this.arrFiles;
this.arrFiles=new Array;
}
this.remotePath=path;
if(path=="/"){
this.objHttp.doRequest("GET",path,"",null,null,this,false,"listBuckets",false);
}else{
var _16b=path.substring(0,path.indexOf("/",1));
var _16c=path.substr(path.indexOf("/",1)+1);
_16c=encodeURI(_16c);
var _16d="&delimiter=/";
if(_168){
_16d="";
}
if(_169==null){
_169="";
}
var _16e=this;
var _16f=function(_170){
var _171=_170.xmlDoc;
if(_171==null){
s3_remoteTreeView.displayFiles(_16e);
return;
}
with(_16e){
var _172=remotePath.substring(0,remotePath.indexOf("/",1)+1);
var _173=remotePath.replace(_172,"");
_172=_172.replace(/\//gi,"");
var _174=_171.getElementsByTagName("Contents");
for(var i=0;i<_174.length;i++){
var _176=_174[i].getElementsByTagName("Key")[0].firstChild.nodeValue;
var _177=_174[i].getElementsByTagName("LastModified")[0].firstChild.nodeValue;
var _178=_174[i].getElementsByTagName("Size")[0].firstChild.nodeValue;
var _179=false;
var eTag=_174[i].getElementsByTagName("ETag")[0].firstChild.nodeValue;
if(eTag!=null){
if(eTag=="\"d66759af42f282e1ba19144df2d405d0\""){
_179=true;
}
}
if(_176.indexOf("_$folder$")!=-1){
_179=true;
_176=_176.replace("_$folder$","");
}
_176=_176.replace(_173,"");
var _17b="http://";
var _17c=_17b+_172+".s3.amazonaws.com/"+_173+_176;
_177=s3_Utils.getDate(_177);
if(fileExists(_176)==-1){
var _17d=new s3_remoteFileInfo(_176,_178,_177,_179,remotePath+_176,_17c);
if(eTag!=null){
_17d.eTag=eTag;
}
arrFiles.push(_17d);
}
}
var _17e=_171.getElementsByTagName("CommonPrefixes");
for(var i=0;i<_17e.length;i++){
var _176=_17e[i].getElementsByTagName("Prefix")[0].firstChild.nodeValue;
_176=_176.replace(_173,"");
_176=_176.substring(0,_176.indexOf("/"));
var _179=true;
_177="";
_178=0;
var _17b="http://";
var _17c=_17b+_172+".s3.amazonaws.com/"+_173+_176;
if(fileExists(_176)==-1){
var _17d=new s3_remoteFileInfo(_176,_178,_177,_179,remotePath+_176,_17c);
arrFiles.push(_17d);
}
}
alert(arrFiles.length);
var _17f=_171.getElementsByTagName("IsTruncated")[0].firstChild.nodeValue;
if(_17f=="true"){
listFilesNew(remotePath,false,false,_180);
if(_171.getElementsByTagName("NextMarker").length>0){
var _180=_171.getElementsByTagName("NextMarker")[0].firstChild.nodeValue;
}
}else{
if(_16a==null&&_16e.isDisplay){
s3_remoteTreeView.displayFiles(_16e);
}else{
_16a(_16e);
}
}
}
};
this.objHttp.doRequestNew("GET",_16b,"max-keys=20&prefix="+_16c+_16d+"&marker="+_169,null,null,this,false,"listObjects",false,_16f);
}
},deleteFileNew:function(path,_182,_183){
this.objHttp.doRequestNew("DELETE",path,"",null,"",this,false,"deleteFile",false,function(){
_182(_183);
});
},listDistributions:function(){
var _184=new s3_xhttp();
var self=this;
_184.doRequestDistributions("GET","","",null,"",this,false,function(_186){
if(!_186.hasErrors){
var _187=new Array();
var _188=_186.xmlDoc;
1;
var _189=_188.getElementsByTagName("DistributionSummary");
for(var i=0;i<_189.length;i++){
var id=s3_Utils.getTagValue(_189[i],"Id");
var _18c=s3_Utils.getTagValue(_189[i],"Status");
var _18d=s3_Utils.getTagValue(_189[i],"LastModifiedTime");
var _18e=s3_Utils.getTagValue(_189[i],"DomainName");
var _18f=s3_Utils.getTagValue(_189[i],"Origin");
var _190=s3_Utils.getTagValue(_189[i],"Comment");
_187.push(new s3_distribution(id,_18e,_18f,_18c,_18d,_190));
}
if(self.callbackFunc!=null){
self.callbackFunc.call(self.callbackObj,_187);
}
}else{
self.setError(_186.statusMesg,true);
}
});
},createDistribution:function(_191,_192,_193,_194){
var _195=new s3_xhttp();
var self=this;
var _197="";
if(s3_Utils.trim(_193[0])!=""&&_193.length>0){
for(var k=0;k<_193.length;k++){
_197+=s3_Utils.stringFormat("<CNAME>{0}</CNAME>",_193[k]);
}
}
var _199=s3_Utils.stringFormat("<?xml version=\"1.0\" encoding=\"UTF-8\"?><DistributionConfig xmlns=\"http://cloudfront.amazonaws.com/doc/2008-06-30/\">"+"<Origin>{0}</Origin>"+"<CallerReference>{1}</CallerReference>{4}"+"<Comment>{2}</Comment>"+"<Enabled>{3}</Enabled>"+"</DistributionConfig>",_191,(new Date()).getTime(),_192,_194,_197);
_195.doRequestDistributions("POST","","",null,_199,this,false,function(_19a){
if(!_19a.hasErrors){
var _19b=_19a.xmlDoc;
var id=s3_Utils.getTagValue(_19b,"Id");
var _19d=s3_Utils.getTagValue(_19b,"Status");
var _19e=s3_Utils.getTagValue(_19b,"LastModifiedTime");
var _19f=s3_Utils.getTagValue(_19b,"DomainName");
var _1a0=s3_Utils.getTagValue(_19b,"Origin");
var _1a1=s3_Utils.getTagValue(_19b,"Comment");
var _1a2=s3_Utils.getTagValue(_19b,"CallerReference");
var _1a3=s3_Utils.getTagValue(_19b,"Enabled");
var _1a4=new Array();
var _1a5=_19b.getElementsByTagName("CNAME");
for(var p=0;p<_1a5.length;p++){
_1a4.push(_1a5[p].firstChild.nodeValue);
}
var _1a7=_1a4.join(",");
var dist=new s3_distribution(id,_19f,_1a0,_19d,_19e,_1a1,_1a2,_1a3,_1a7);
if(self.callbackFunc!=null){
self.callbackFunc.call(self.callbackObj,dist);
}
}else{
self.setError(_19a.statusMesg,true);
}
});
},getDistributionInfo:function(_1a9){
var _1aa=new s3_xhttp();
var self=this;
_1aa.doRequestDistributions("GET",_1a9,"",null,"",this,false,function(_1ac){
if(!_1ac.hasErrors){
var _1ad=_1ac.xmlDoc;
var id=s3_Utils.getTagValue(_1ad,"Id");
var _1af=s3_Utils.getTagValue(_1ad,"Status");
var _1b0=s3_Utils.getTagValue(_1ad,"LastModifiedTime");
var _1b1=s3_Utils.getTagValue(_1ad,"DomainName");
var _1b2=s3_Utils.getTagValue(_1ad,"Origin");
var _1b3=s3_Utils.getTagValue(_1ad,"Comment");
var _1b4=s3_Utils.getTagValue(_1ad,"CallerReference");
var _1b5=s3_Utils.getTagValue(_1ad,"Enabled");
var _1b6=new Array();
var _1b7=_1ad.getElementsByTagName("CNAME");
for(var p=0;p<_1b7.length;p++){
_1b6.push(_1b7[p].firstChild.nodeValue);
}
var _1b9=_1b6.join(",");
var dist=new s3_distribution(id,_1b1,_1b2,_1af,_1b0,_1b3,_1b4,_1b5,_1b9);
dist.eTag=_1ac.responseHeaders["Etag"];
if(self.callbackFunc!=null){
self.callbackFunc.call(self.callbackObj,dist);
}
}else{
self.setError(_1ac.statusMesg,true);
}
});
},setDistribution:function(_1bb,_1bc,_1bd,_1be,_1bf,eTag,_1c1){
var _1c2=new s3_xhttp();
var self=this;
var _1c4="";
if(s3_Utils.trim(_1c1[0])!=""&&_1c1.length>0){
for(var k=0;k<_1c1.length;k++){
_1c4+=s3_Utils.stringFormat("<CNAME>{0}</CNAME>",s3_Utils.trim(_1c1[k]));
}
}
var _1c6=s3_Utils.stringFormat("<?xml version=\"1.0\" encoding=\"UTF-8\"?><DistributionConfig xmlns=\"http://cloudfront.amazonaws.com/doc/2008-06-30/\">"+"<Origin>{0}</Origin>"+"<CallerReference>{1}</CallerReference>{4}"+"<Comment>{2}</Comment>"+"<Enabled>{3}</Enabled>"+"</DistributionConfig>",_1bb,_1be,_1bc,_1bd,_1c4);
_1c2.doRequestDistributions("PUT",_1bf+"/config","",[{"name":"If-Match","value":eTag}],_1c6,this,false,function(_1c7){
if(!_1c7.hasErrors){
var _1c8=_1c7.xmlDoc;
if(self.callbackFunc!=null){
self.callbackFunc.call(self.callbackObj,true);
}
}else{
self.setError(_1c7.statusMesg,true);
if(self.callbackFunc!=null){
self.callbackFunc.call(self.callbackObj,false);
}
}
});
},deleteDistribution:function(_1c9,eTag){
var _1cb=new s3_xhttp();
var self=this;
_1cb.doRequestDistributions("DELETE",_1c9,"",[{"name":"If-Match","value":eTag}],"",this,false,function(_1cd){
if(!_1cd.hasErrors){
if(self.callbackFunc!=null){
self.callbackFunc.call(self.callbackObj,true);
}
}else{
self.setError(_1cd.statusMesg,true);
if(self.callbackFunc!=null){
self.callbackFunc.call(self.callbackObj,false);
}
}
});
}};

