function s3_clsActionTreeView(_1){
this.isSyncTransfer=_1;
this.arrActionQ=new Array;
this.treeBox=null;
this.startIndex=0;
this.downIndex=0;
this.uploadIndex=0;
this.maxConcurrentUploads=1;
this.numConcurrentUploads=0;
this.maxConcurrentDownloads=1;
this.numConcurrentDownloads=0;
this.selection=null;
this.isPaused=false;
this.progTimer=null;
this.isError=0;
this.isRemoteListValid=true;
this.activeItems={};
}
s3_clsActionTreeView.prototype={getRowCount:function(){
this.rowCount=this.arrActionQ.length;
return this.arrActionQ.length;
},setTree:function(_2){
this.treeBox=_2;
},getCellText:function(_3,_4){
if(_3>=this.getRowCount()){
return "";
}
var _5=this.arrActionQ[_3];
var _6="";
var _7=(_5.statusMesg!=null)?_5.statusMesg:"";
var _8=(this.isSyncTransfer==true)?"Sync":"";
switch(_4.id){
case "s3_actFileName"+_8:
_6=_5.fileName;
break;
case "s3_actType"+_8:
_6=(_5.actType=="download")?"Download":"Upload";
_6+=" ("+_5.intProgress+"%"+") ";
break;
case "s3_actFrom"+_8:
_6=_5.fromPath;
break;
case "s3_actTo"+_8:
_6=_5.toPath;
break;
case "s3_actStatus"+_8:
if(_5.status==s3_progStatus.INIT){
_6=s3_Utils.getPropertyString("inqueue");
}else{
if(_5.status==s3_progStatus.PROGRESS){
_6=s3_Utils.getPropertyString("processing");
}else{
if(_5.status==s3_progStatus.COMPLETED){
_6=s3_Utils.getPropertyString("completed")+" "+_7;
}else{
if(_5.status==s3_progStatus.FAILED){
_6=s3_Utils.getPropertyString("failed")+" "+_5.errorMesg;
}
}
}
}
break;
}
return _6;
},isEditable:function(_9,_a){
return true;
},isContainer:function(_b){
return false;
},isSeparator:function(_c){
return false;
},isSorted:function(){
return false;
},getImageSrc:function(_d,_e){
if(_d>=this.getRowCount()){
return "";
}
var _f=this.arrActionQ[_d];
var _10="";
var _11=(this.isSyncTransfer==true)?"Sync":"";
switch(_e.id){
case "s3_actFileName"+_11:
if(_f.isDirectory){
_10="chrome://s3fox/content/images/directory.png";
}else{
_10="moz-icon://"+this.arrActionQ[_d].fileName+"?size=16";
}
break;
case "s3_actType"+_11:
_10=(_f.actType=="download")?"chrome://s3fox/content/images/down.png":"chrome://s3fox/content/images/up.png";
break;
case "s3_actStatus"+_11:
if(_f.status==s3_progStatus.INIT){
_10="chrome://s3fox/content/images/queue.png";
}else{
if(_f.status==s3_progStatus.PROGRESS){
_10="chrome://s3fox/content/images/exec.png";
}else{
if(_f.status==s3_progStatus.COMPLETED){
_10="chrome://s3fox/content/images/ok.png";
}else{
if(_f.status==s3_progStatus.FAILED){
_10="chrome://s3fox/content/images/no.png";
}
}
}
}
break;
}
return _10;
},canDrop:function(idx,_13){
if(_13!=Components.interfaces.DROP_ON){
return false;
}else{
return true;
}
},drop:function(idx,_15){
},getParentIndex:function(idx){
return -1;
},getProgressMode:function(idx,_18){
if(_18.id=="s3_actProgress"){
return Components.interfaces.nsITreeView.PROGRESS_NORMAL;
}
if(_18.id=="s3_actProgressSync"){
return Components.interfaces.nsITreeView.PROGRESS_NORMAL;
}
return 0;
},getCellValue:function(idx,_1a){
if(idx>=this.getRowCount()){
return "";
}
var _1b=this.arrActionQ[idx];
var _1c=(this.isSyncTransfer==true)?"Sync":"";
if(_1a.id=="s3_actProgress"+_1c){
return _1b.intProgress;
}else{
return null;
}
},cycleHeader:function(col,_1e){
},selectionChanged:function(){
},cycleCell:function(idx,_20){
},performAction:function(_21){
},performActionOnCell:function(_22,_23,_24){
},getRowProperties:function(idx,_26,_27){
},getCellProperties:function(idx,_29,_2a){
if(idx>=this.getRowCount()){
return "";
}
var _2b=this.arrActionQ[idx];
var _2c=(this.isSyncTransfer==true)?"Sync":"";
if(_29.id=="s3_actProgress"+_2c){
var _2d=Components.classes["@mozilla.org/atom-service;1"].getService(Components.interfaces.nsIAtomService);
if(_2b.actType=="download"){
_2a.AppendElement(_2d.getAtom("download"));
}else{
_2a.AppendElement(_2d.getAtom("upload"));
}
}
},getColumnProperties:function(_2e,_2f,_30){
},getLevel:function(idx){
return 0;
},getActionInstance:function(_32,_33){
return new s3_Action(_32.accessCode,_32.secretKey,_32.isSecure,this,_33);
},ProcessActionQ:function(_34){
if(this.downIndex<0){
this.downIndex=0;
}
if(this.uploadIndex<0){
this.uploadIndex=0;
}
if(_34!=null&&_34.indexOf("down")!=-1){
s3_remoteTreeView.selection.clearSelection();
}else{
if(!s3_uiManager.isOverlay){
s3_localTreeView.selection.clearSelection();
s3_localTreeView.thumbnailClearSelection();
}
}
var _35=this;
setTimeout(function(){
_35.Download();
},500);
setTimeout(function(){
_35.Upload();
},200);
},clearItems:function(_36){
if(!_36&&(this.downIndex<this.getRowCount()||this.uploadIndex<this.getRowCount())){
var _37=Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
var chk=_37.confirm(window,"Confirm",s3_Utils.getPropertyString("uploadProgress")+s3_Utils.getPropertyString("unexpected"));
if(!chk){
return;
}
}
var _39=this.getRowCount();
delete this.arrActionQ;
this.arrActionQ=new Array;
if(this.treeBox){
this.treeBox.rowCountChanged(0,-_39);
}
this.downIndex=0;
this.uploadIndex=0;
this.numConcurrentDownloads=0;
this.numConcurrentUploads=0;
},removeFromQ:function(){
var _3a=new Object();
var end=new Object();
var _3c=-this.getRowCount();
var _3d=this.selection.getRangeCount();
var _3e=0;
for(var t=0;t<_3d;t++){
this.selection.getRangeAt(t,_3a,end);
for(var v=_3a.value;v<=end.value;v++){
var _41=v-_3e;
if(this.arrActionQ[_41].status==s3_progStatus.PROGRESS){
continue;
}
this.arrActionQ.splice(_41,1);
_3e++;
(v<this.downIndex)?this.downIndex--:this.downIndex;
(v<this.uploadIndex)?this.uploadIndex--:this.uploadIndex;
}
}
if(this.treeBox){
this.treeBox.rowCountChanged(0,_3c);
this.treeBox.rowCountChanged(0,this.getRowCount());
}
},clearCompleted:function(){
var _42=-this.getRowCount();
for(var k=0;k<this.arrActionQ.length;k++){
if(this.arrActionQ[k].status==s3_progStatus.COMPLETED){
this.arrActionQ.splice(k,1);
k--;
}
}
this.downIndex=0;
this.uploadIndex=0;
if(this.treeBox){
this.treeBox.rowCountChanged(0,_42);
this.treeBox.rowCountChanged(0,this.getRowCount());
}
},retryFailedTasks:function(){
var _44=-this.getRowCount();
var _45=0;
for(var k=0;k<this.arrActionQ.length;k++){
if(this.arrActionQ[k].status==s3_progStatus.FAILED){
if(_45==0){
_45=(k==0)?0:k-1;
}
this.arrActionQ[k].status=s3_progStatus.INIT;
}
}
this.downIndex=_45;
this.uploadIndex=_45;
if(this.treeBox){
this.treeBox.rowCountChanged(0,_44);
this.treeBox.rowCountChanged(0,this.getRowCount());
}
var _47=this;
setTimeout(function(){
_47.Download();
},500);
setTimeout(function(){
_47.Upload();
},500);
},Download:function(_48){
if(this.isPaused){
return;
}
if(this.downIndex>=this.getRowCount()){
return;
}
var _49=this;
try{
while(this.numConcurrentDownloads<this.maxConcurrentDownloads){
var _4a;
while(this.downIndex<this.getRowCount()){
_4a=this.arrActionQ[this.downIndex];
if(_4a.actType=="download"){
if(_4a.status==s3_progStatus.INIT){
break;
}else{
if(_4a.status==s3_progStatus.PROGRESS){
if((new Date).getTime()-_4a.lastUpdated>1000*60){
var evt={};
evt.isError=1;
evt.errorMesg="Download Time out!";
evt.tActionRow=_4a;
this.handleDownloadEvent(evt);
}
}
this.downIndex++;
}
}else{
this.downIndex++;
}
}
if(this.downIndex>=this.getRowCount()){
this.isError=0;
if(_48&&!s3_uiManager.isOverlay){
s3_localTreeView.refreshFolder();
}
return;
}
this.numConcurrentDownloads++;
_4a.index=this.downIndex;
this.activeItems[_4a.actionId]=_4a;
_4a.status=s3_progStatus.PROGRESS;
var act=this.getActionInstance(_4a.authInfo,function(_4d){
this.numConcurrentDownloads--;
if(_4d.isSuccess){
this.activeItems[_4d.actionId].intProgress=100;
this.activeItems[_4d.actionId].status=s3_progStatus.COMPLETED;
if(_4d.statusMessage){
this.activeItems[_4d.actionId].statusMesg=_4d.statusMessage;
}
}else{
this.activeItems[_4d.actionId].intProgress=0;
this.activeItems[_4d.actionId].status=s3_progStatus.FAILED;
this.activeItems[_4d.actionId].errorMesg=_4d.statusMessage;
}
this.InvalidateTree(this.activeItems[_4d.actionId].index);
setTimeout(function(){
_49.Download(true);
},10);
this.activeItems[_4d.actionId]=null;
});
act.downloadObject(_4a.actionId,_4a.fileName,_4a.fromPath,_4a.toPath,_4a.fileSize,_4a.downloadKeepOriginal,_4a.isDirectory,_4a.existObjectInfo,function(_4e){
this.activeItems[_4e.actionId].intProgress=_4e.progress;
this.InvalidateTree(this.activeItems[_4e.actionId].index);
});
s3_logView.log("Dowloading file - "+_4a.toPath+_4a.fileName,"message");
}
}
catch(ex){
alert(ex);
}
},InvalidateTree:function(row){
if(this.treeBox==null){
return;
}
if(row!=null&&row!=-1&&row<this.getRowCount()){
this.treeBox.invalidateRow(row);
var _50=this.arrActionQ[row];
if(_50.displayed||!this.isSyncTransfer){
return;
}
if(_50.actType=="download"){
if(this.uploadIndex<this.getRowCount()){
return;
}
s3_get("s3_fileProgress").setAttribute("uploadType","download");
}else{
s3_get("s3_fileProgress").setAttribute("uploadType","upload");
}
s3_get("s3_stackProgress").style.visibility="visible";
var txt=_50.fileName;
txt+=" ("+_50.intProgress+"%"+") - ";
if(_50.status==s3_progStatus.INIT){
txt+=s3_Utils.getPropertyString("inqueue");
}else{
if(_50.status==s3_progStatus.PROGRESS){
txt+=s3_Utils.getPropertyString("processing");
}else{
if(_50.status==s3_progStatus.COMPLETED){
txt+=s3_Utils.getPropertyString("completed");
_50.displayed=true;
}else{
if(_50.status==s3_progStatus.FAILED){
txt+=s3_Utils.getPropertyString("failed")+" "+_50.errorMesg;
_50.displayed=true;
}
}
}
}
s3_get("s3_sbFileName").value=txt;
var _52=Components.classes["@mozilla.org/atom-service;1"].getService(Components.interfaces.nsIAtomService);
s3_get("s3_fileProgress").value=_50.intProgress;
if(this.progBarTimer!=null){
clearTimeout(this.progBarTimer);
}
if(_50.intProgress==100||_50.status==s3_progStatus.FAILED){
this.progBarTimer=setTimeout(function(){
s3_get("s3_sbFileName").value="";
s3_get("s3_fileProgress").value=0;
s3_get("s3_stackProgress").style.visibility="hidden";
},10000);
}
}else{
this.treeBox.invalidate();
}
},Upload:function(_53){
if(this.isPaused){
return;
}
if(this.uploadIndex>=this.getRowCount()){
return;
}
var _54=this;
setTimeout(function(){
_54.UploadFile(_53);
},100);
},UploadFile:function(_55){
var _56=this;
try{
while(this.numConcurrentUploads<this.maxConcurrentUploads){
var _57;
while(this.uploadIndex<this.getRowCount()){
_57=this.arrActionQ[this.uploadIndex];
if(_57.actType=="upload"){
if(_57.status==s3_progStatus.INIT){
break;
}else{
if(_57.status==s3_progStatus.PROGRESS){
if((new Date).getTime()-_57.lastUpdated>1000*60){
var evt={};
evt.isError=1;
evt.errorMesg="Upload Time out!";
evt.tActionRow=_57;
this.handleUploadEvent(evt);
}
}
this.uploadIndex++;
}
}else{
this.uploadIndex++;
}
}
if(this.uploadIndex>=this.getRowCount()){
this.isError=0;
if(_55){
s3_remoteTreeView.refreshFolder();
}
return;
}
this.numConcurrentUploads++;
_57.index=this.uploadIndex;
this.activeItems[_57.actionId]=_57;
_57.status=s3_progStatus.PROGRESS;
var act=this.getActionInstance(_57.authInfo,function(_5a){
this.numConcurrentUploads--;
if(_5a.isSuccess){
this.activeItems[_5a.actionId].intProgress=100;
this.activeItems[_5a.actionId].status=s3_progStatus.COMPLETED;
if(_5a.statusMessage){
this.activeItems[_5a.actionId].statusMesg=_5a.statusMessage;
}
}else{
this.activeItems[_5a.actionId].intProgress=0;
this.activeItems[_5a.actionId].status=s3_progStatus.FAILED;
this.activeItems[_5a.actionId].errorMesg=_5a.statusMessage;
}
this.InvalidateTree(this.activeItems[_5a.actionId].index);
setTimeout(function(){
_56.Upload(true);
},10);
this.activeItems[_5a.actionId]=null;
});
act.uploadObject(_57.actionId,_57.fileName,_57.fromPath,_57.toPath,_57.existObjectInfo,function(_5b){
this.activeItems[_5b.actionId].intProgress=_5b.progress;
this.InvalidateTree(this.activeItems[_5b.actionId].index);
});
s3_logView.log("Uploading file - "+_57.toPath+_57.fileName,"message");
}
}
catch(ex){
alert(ex);
}
},pauseQ:function(_5c){
var _5d=(_5c=="sync")?"s3_action_pauseSync":"s3_action_pause";
if(this.isPaused){
this.isPaused=false;
s3_get(_5d).setAttribute("label","Pause");
s3_get(_5d).setAttribute("image","chrome://s3fox/content/images/pause.png");
this.ProcessActionQ();
}else{
s3_get(_5d).setAttribute("label","Resume");
s3_get(_5d).setAttribute("image","chrome://s3fox/content/images/play.png");
this.isPaused=true;
}
}};
var s3_actionTreeView=new s3_clsActionTreeView(false);

