var s3_OperationCodes={FILE_LIST:1,RENAME:2,CREATE_FOLDER:3,DELETE:4,GET_ACL:5,SET_ACL:6,SYNC_GET:7,SYNC_PUT:8,UPLOAD:9,DOWNLOAD:10};
function s3_get(_1,_2){
if(_2==null){
return document.getElementById(_1);
}else{
return _2.getElementById(_1);
}
}
function s3_ffVersion(){
if("@mozilla.org/login-manager;1" in Components.classes){
return "3.x";
}else{
return "2.x";
}
}
var s3_fileOpPref={CANCEL:0,OVERWRITE_DELETE:1,OVERWRITE_DELETE_ALL:2,SKIP:3,SKIP_ALL:4,KEEP_ORIGINAL:5,KEEP_ORIGINAL_ALL:6,overwriteOption:1,askOption:true};
function s3_distribution(id,_4,_5,_6,_7,_8,_9,_a,_b){
this.id=id;
this.domainName=_4;
this.origin=_5;
this.status=_6;
this.lastModifiedTime=_7;
this.comment=_8;
this.callerReference=_9;
this.enabled=_a;
this.eTag;
this.cnames=_b;
this.hasFullData=false;
}
function s3_response(_c,_d,_e,_f,_10){
this.xmlDoc=_c;
this.responseText=_d;
this.responseHeaders=_e;
this.statusMesg=_f;
this.hasErrors=(_10!=null);
this.file=null;
}
function s3_remoteFileInfo(_11,_12,_13,_14,_15,key){
this.fileName=_11;
this.arrInfo=new Array;
this.fileSize=_12;
this.key=key;
this.fileSizeInKb=Math.ceil(_12/1000);
this.modifiedTime=_13;
this.isDirectory=_14;
this.filePath=_15;
this.folderPath=_15.substring(0,_15.lastIndexOf("/",_15.length-1));
this.strAcp=null;
this.permissions=null;
this.eTag=null;
this.properties=null;
}
function s3_localFileInfo(_17,_18,_19,_1a,_1b,_1c){
this.filePath=_17;
this.fileName=_18;
this.parentPath=_19;
this.fileSize=_1a;
this.fileSizeInKb=Math.ceil(_1a/1000);
this.modifiedTime=_1b;
this.isDirectory=_1c;
this.isSelected=false;
}
function s3_actionRow(_1d,_1e,_1f,_20,_21,_22,_23,_24,_25,key,_27){
this.fromPath=_1d;
this.toPath=_1e;
this.fileName=_1f;
this.actType=_21;
this.fileSizeInKb=Math.ceil(_22/1000);
this.fileSize=_22;
this.status=_20;
this.progress=_23;
this.isDirectory=_24;
this.intProgress=0;
this.sysModifiedTime="";
this.permissions=null;
this.objAct=_27;
this.key=key;
this.errorMesg="";
this.index=0;
this.objFileInfo=_25;
this.lastUpdated=null;
this.isSyncActions=false;
}
function s3_extend(_28,_29){
_28.prototype.__proto__=_29.prototype;
_28.prototype.baseObj=_29;
}
function s3_removeFromQ(_2a){
if(_2a=="sync"){
s3_syncActionsTreeView.removeFromQ();
}else{
s3_actionTreeView.removeFromQ();
}
}
function s3_pauseQ(_2b){
if(_2b=="sync"){
s3_syncActionsTreeView.pauseQ(_2b);
}else{
s3_actionTreeView.pauseQ(_2b);
}
}
function s3_clearItems(_2c){
if(_2c=="sync"){
s3_syncActionsTreeView.clearItems();
}else{
s3_actionTreeView.clearItems();
}
}
function s3_showWaitIcon(_2d){
if(_2d){
s3_get("s3_processingIcon").hidden=false;
clearTimeout(s3_uiManager.iconTimer);
s3_uiManager.iconTimer=setTimeout(function(){
s3_get("s3_processingIcon").hidden=true;
},60000);
}else{
s3_get("s3_processingIcon").hidden=true;
}
}
var s3_progStatus={LOGIN:1,LOGOUT:-1,INIT:2,PROGRESS:3,COMPLETED:4,FAILED:5,UPLOADCOMPLETE:6,DOWNLOADCOMPLETE:7,WAITING:8,NOCONFIRMATION:9,PREUPLOAD:10,PREDOWNLOAD:11};
function s3_fireEvent(_2e,_2f,_30,doc){
if(doc==null){
doc=document;
}
var evt=doc.createEvent("Events");
evt.initEvent(_2e,true,true);
for(var _33 in _30){
evt[_33]=_30[_33];
}
_2f.dispatchEvent(evt);
}
function s3_setSignature(_34,_35,_36,_37,_38,_39,_3a){
_36=encodeURI(_36);
var _3b=s3_getBucketFromUrl(_36);
var _3c=_36.replace("/"+_3b,"");
if(_3c==""&&_36!="/"){
_3c="/";
}
_36="/"+_3b+_3c;
if(_39!=null&&_39){
_36+=_37;
}
var _3d=new Date();
var _3e=_35+"\n\n"+s3_Utils.trim(_3a)+"\n"+_3d.toUTCString()+"\n"+_38+_36;
if(_34){
var _3f="AWS "+s3_uiManager.accessCode+":";
}else{
var _3f="Authorization:AWS "+s3_uiManager.accessCode+":";
}
s3_dump(s3_uiManager.accessCode+", "+_3e);
var sig=s3_encUtils.b64_hmac_sha1(s3_uiManager.secretKey,_3e);
_3f+=sig;
if(_34){
_34.setRequestHeader("Authorization",_3f);
_34.setRequestHeader("Date",_3d.toUTCString());
if(s3_Utils.trim(_3a)!=""){
_34.setRequestHeader("Content-Type",_3a);
}
}else{
_3f+="\r\n";
_3f+="Date:"+_3d.toUTCString()+"\r\n";
}
return _3f;
}
function s3_getBucketFromUrl(_41){
var _42=_41.indexOf("/",1);
var _43=_41.length;
if(_42!=-1){
_43=_42;
}
var _44=_41.substring(1,_43);
_44=_44.replace(/\/|\\/gi,"");
return _44;
}
function s3_getHostUrl(_45,_46,_47){
var _48,_49;
if(s3_uiManager.isSecure){
_48="https://";
_49="https://s3.amazonaws.com";
}else{
_48="http://";
_49="http://s3.amazonaws.com";
}
var _4a=s3_getBucketFromUrl(_46);
var url;
var _4c=new RegExp("/"+_4a+"/|/"+_4a);
var _4d=_46.replace(_4c,"");
if(_4a.toLowerCase()===_4a&&_4a!=""){
url=_48+_4a+".s3.amazonaws.com/"+_4d;
}else{
if(_4a!=""){
_4a+="/";
}
url=_48+"s3.amazonaws.com/"+_4a+_4d;
}
return url+_47;
}
function s3_setSignatureDistribution(_4e,_4f,_50,_51,_52,_53){
var _54=new Date();
var _55=_54.toUTCString();
if(_4e){
var _56="AWS "+s3_uiManager.accessCode+":";
}else{
var _56="Authorization:AWS "+s3_uiManager.accessCode+":";
}
s3_dump(s3_uiManager.accessCode+", "+_55);
var sig=s3_encUtils.b64_hmac_sha1(s3_uiManager.secretKey,_55);
_56+=sig;
if(_4e){
_4e.setRequestHeader("Authorization",_56);
_4e.setRequestHeader("Date",_54.toUTCString());
if(s3_Utils.trim(_53)!=""){
_4e.setRequestHeader("Content-Type",_53);
}
}else{
_56+="\r\n";
_56+="Date:"+_54.toUTCString()+"\r\n";
}
return _56;
}
function s3_getHostUrlDistribution(_58,_59,_5a){
var _5b="https://cloudfront.amazonaws.com/2008-06-30/distribution/";
return _5b+_59+_5a;
}
function s3_savePwd(_5c,_5d,_5e){
var _5f=_5c;
if("@mozilla.org/passwordmanager;1" in Components.classes){
var _60=Components.classes["@mozilla.org/passwordmanager;1"].createInstance(Components.interfaces.nsIPasswordManager);
try{
_60.removeUser(host,_5d);
}
catch(ex){
}
_60.addUser(_5c,_5d,_5e);
}else{
if("@mozilla.org/login-manager;1" in Components.classes){
try{
var _61=null;
var _62=Components.classes["@mozilla.org/login-manager;1"].getService(Components.interfaces.nsILoginManager);
var _63=_62.findLogins({},_5c,null,_5f);
for(var i=0;i<_63.length;i++){
if(_63[i].username==_5d){
_61=_63[i];
break;
}
}
}
catch(ex){
}
var _65=new Components.Constructor("@mozilla.org/login-manager/loginInfo;1",Components.interfaces.nsILoginInfo,"init");
var _66=new _65(_5c,null,_5f,_5d,_5e,"","");
if(_61!=null){
_62.modifyLogin(_61,_66);
}else{
_62.addLogin(_66);
}
}
}
}
function s3_getPwd(_67,_68){
var _69=_67;
var pwd="";
if("@mozilla.org/passwordmanager;1" in Components.classes){
var _6b=Components.classes["@mozilla.org/passwordmanager;1"].createInstance(Components.interfaces.nsIPasswordManagerInternal);
var _6c={value:""};
var _6d={value:""};
var _6e={value:""};
try{
_6b.findPasswordEntry(_67,_68,"",_6c,_6d,_6e);
pwd=_6e.value;
}
catch(e){
}
}else{
if("@mozilla.org/login-manager;1" in Components.classes){
try{
var _6f=Components.classes["@mozilla.org/login-manager;1"].getService(Components.interfaces.nsILoginManager);
var _70=_6f.findLogins({},_67,"",_69);
for(var i=0;i<_70.length;i++){
if(_70[i].username==_68){
pwd=_70[i].password;
break;
}
}
}
catch(ex){
}
}
}
return pwd;
}
function s3_removePwd(_72,_73){
var _74=_72;
if("@mozilla.org/passwordmanager;1" in Components.classes){
var _75=Components.classes["@mozilla.org/passwordmanager;1"].createInstance();
try{
_75.removeUser(_72,_73);
}
catch(ex){
}
}else{
if("@mozilla.org/login-manager;1" in Components.classes){
try{
var _76=Components.classes["@mozilla.org/login-manager;1"].getService(Components.interfaces.nsILoginManager);
var _77=_76.findLogins({},_72,null,_74);
for(var i=0;i<_77.length;i++){
if(_77[i].username==_73){
_76.removeLogin(_77[i]);
break;
}
}
}
catch(ex){
}
}
}
}
var s3_modalDialog={left:null,top:null,width:480,height:360,_callbackFunc:null,_source:null,_keyFunc:null,resetDimensions:function(){
this.left=null;
this.top=null;
this.width=480;
this.height=360;
},setDimensions:function(_79){
if(_79.left!=null){
s3_modalDialog.left=_79.left;
}
if(_79.top!=null){
s3_modalDialog.top=_79.top;
}
if(_79.width!=null){
s3_modalDialog.width=_79.width;
}
if(_79.height!=null){
s3_modalDialog.height=_79.height;
}
},setDialogSize:function(){
s3_get("s3_dlgPanel").style.width=s3_modalDialog.width+"px";
var _7a=0;
if(!s3_get("s3_dlgPanelDesc").hidden){
_7a=s3_get("s3_dlgPanel_header").boxObject.height;
}
s3_get("s3_modalDialog").style.height=(s3_modalDialog.height+_7a)+"px";
s3_get("s3_dlgPanel_frame").style.height=(s3_get("s3_dlgPanel").boxObject.height-_7a-2)+"px";
},setDialogPosition:function(){
if(isNaN(parseInt(s3_modalDialog.left,10))||isNaN(parseInt(s3_modalDialog.top,10))){
var _7b=((s3_get("s3_window").boxObject.width/2)-(s3_get("s3_modalDiv").offsetWidth/2));
var top=((s3_get("s3_window").boxObject.height/2)-(s3_get("s3_modalDiv").offsetHeight/2));
s3_get("s3_modalDiv").style.left=_7b+"px";
s3_get("s3_modalDiv").style.top=top+"px";
}else{
s3_get("s3_modalDiv").style.left=s3_modalDialog.left+"px";
s3_get("s3_modalDiv").style.top=s3_modalDialog.top+"px";
}
},showDialog:function(_7d,_7e,_7f){
s3_get("s3_mask").hidden=false;
s3_get("s3_modalDialog").hidden=false;
s3_get("s3_modalDialogContent").setAttribute("type",_7d);
s3_modalDialog.setDialogPosition();
this._callbackFunc=_7f;
this._source=_7e;
var _80=this;
this._keyFunc=function(evt){
if(evt.keyCode==27){
_80.closeDialog();
}
};
document.addEventListener("keypress",this._keyFunc,false);
var _80=this;
setTimeout(function(){
if(_80.onLoad){
_80.onLoad.apply(_80.onLoadObject,[s3_get("s3_modalDialogContent")]);
}
},1);
},closeDialog:function(){
s3_get("s3_mask").hidden=true;
s3_get("s3_modalDialog").hidden=true;
document.removeEventListener("keypress",this._keyFunc,false);
},doOk:function(){
var _82=this;
setTimeout(function(){
if(_82._callbackFunc){
_82._callbackFunc.call(_82._source,s3_get("s3_modalDialogContent"));
}
},1);
this.closeDialog();
},doCancel:function(){
var _83=this;
setTimeout(function(){
if(_83._callbackFunc){
_83._callbackFunc.call(_83._source,null);
}
},1);
this.closeDialog();
}};
function s3_TaskListInfo(_84,_85,_86,_87){
this.id=_84;
this.type=_85;
this.info=_86||"";
this.properties=_87||{};
this.isError=false;
}
function s3_Response(_88,_89,_8a,_8b,_8c){
this.xmlDoc=_88;
this.responseText=_89;
this.responseHeaders=_8a;
this.statusMessage=_8b;
this.hasErrors=(_8c!=null);
this.file=null;
}
function s3_Operation(_8d,_8e,_8f){
this.opId=_8e||(new Date()).getTime();
this.opCode=_8d;
this.info=_8f;
this.callbackScope;
this.onComplete;
}
function s3_Header(_90,_91){
this.name=_90;
this.value=_91;
}
function s3_Error(_92,_93){
this.errorMessage=_92;
this.errorType=_93;
}
function s3_HandleError(evt){
alert(evt.errorMessage);
}
function s3_QItem(key,_96,_97,_98){
this.itemId=(new Date()).getTime()+""+Math.ceil(10000*Math.random());
this.key=key;
this.authInfo=_96;
this.priority=_97;
this.properties=_98;
this.status=s3_progStatus.INIT;
this.actionInstance;
}
function s3_AuthInfo(_99,_9a,_9b){
this.accessCode=_99;
this.secretKey=_9a;
this.scheme=_9b;
}
function s3_ActionRow(_9c,_9d,_9e,_9f,_a0,_a1,_a2,_a3,_a4,_a5,_a6){
this.fromPath=_9c;
this.toPath=_9d;
this.fileName=_9e;
this.actType=_a0;
this.fileSizeInKb=Math.ceil(_a1/1000);
this.fileSize=_a1;
this.status=_9f;
this.progress=_a2;
this.isDirectory=_a3;
this.intProgress=0;
this.sysModifiedTime="";
this.permissions=null;
this.authInfo=_a5;
this.actionId=_a6||(new Date()).getTime()+""+Math.ceil(10000*Math.random());
this.errorMesg="";
this.index=0;
this.existObjectInfo=_a4;
this.lastUpdated=null;
this.downloadKeepOriginal=false;
}
function s3_Event(){
this.listeners={};
}
s3_Event.prototype={registerEvents:function(_a7){
for(var i=0;i<_a7.length;i++){
this.listeners[_a7[i]]=new Array();
}
},addListener:function(_a9,_aa,fn){
if(this.listeners.hasOwnProperty(_a9)){
this.listeners[_a9].push({scope:_aa,fn:fn});
}else{
throw "Event not supported";
}
},fireEvent:function(_ac,_ad){
if(this.listeners.hasOwnProperty(_ac)){
this.listeners[_ac].forEach(function(val,_af,arr){
if(typeof (val.fn)=="function"){
val.fn.apply(val.scope,_ad);
}
});
}
},removeListener:function(_b1){
delete this.listeners[_b1];
}};
function s3_Task(_b2){
this.eventManager=new s3_Event();
this.processItems=new Array();
this.currentIndex=0;
this.indexDirty=false;
this.isAborted=false;
this.currentItem=null;
this.taskId=_b2||(new Date()).getTime();
this.properties={};
}
s3_Task.prototype={inheritProperties:function(){
for(var i=0;i<arguments.length;i++){
arguments[i].call(this);
}
},sortPriority:function(x,y){
if(x.priority<y.priority){
return -1;
}else{
if(x.priority>y.priority){
return 1;
}
}
return 0;
},getActionInstance:function(_b6,_b7){
return new s3_Action(_b6.accessCode,_b6.secretKey,_b6.isSecure,this,_b7);
},getNextIndex:function(){
var _b8=this.currentIndex;
if(this.indexDirty){
_b8=0;
}
for(var i=_b8;i<this.processItems.length;i++){
if(this.processItems[i].status==s3_progStatus.INIT){
break;
}
}
return i;
},addTaskProperty:function(_ba,_bb){
this.properties[_ba]=_bb;
},addTask:function(_bc,_bd){
if(this.updateView){
s3_taskView.add(new s3_TaskListInfo(this.taskId,_bc,_bd));
}
},updateTask:function(_be){
if(this.updateView){
s3_taskView.updateItem(this.taskId,_be);
}
},setTaskError:function(){
if(this.updateView){
s3_taskView.setError(this.taskId);
}
},removeTask:function(){
if(this.updateView){
s3_taskView.remove(this.taskId);
}
}};
function s3_Grantee(_bf,id,_c1){
this.type=_bf;
this.id=id;
this.name=_c1;
this.arrPermissions=new Array();
}
function s3_AccessPolicy(){
this.grant=new Array();
this.owner=null;
}
s3_AccessPolicy.prototype={toXml:function(){
},addGrantee:function(_c2){
this.grant.push(_c2);
},deleteGrantee:function(_c3){
var pos=findGrantee(_c3.id);
this.grant.splice(pos,1);
},findGrantee:function(id){
var _c6=-1;
for(var i=0;i<this.grant.length;i++){
if(id!=null&&this.grant[i].id==id){
_c6=i;
break;
}
}
return _c6;
},addPermissions:function(_c8){
var pos=findGrantee(_c8.id);
this.grant[pos].arrPermissions=_c8.arrPermissions;
}};

