var s3_encUtils={hexcase:0,b64pad:"=",chrsz:8,hex_sha1:function(s){
return this.binb2hex(this.core_sha1(this.str2binb(s),s.length*this.chrsz));
},b64_sha1:function(s){
return this.binb2b64(this.core_sha1(this.str2binb(s),s.length*this.chrsz));
},str_sha1:function(s){
return this.binb2str(this.core_sha1(this.str2binb(s),s.length*this.chrsz));
},hex_hmac_sha1:function(_4,_5){
return this.binb2hex(this.core_hmac_sha1(_4,_5));
},b64_hmac_sha1:function(_6,_7){
return this.binb2b64(this.core_hmac_sha1(_6,_7));
},str_hmac_sha1:function(_8,_9){
return this.binb2str(this.core_hmac_sha1(_8,_9));
},sha1_vm_test:function(){
return hex_sha1("abc")=="a9993e364706816aba3e25717850c26c9cd0d89d";
},core_sha1:function(x,_b){
x[_b>>5]|=128<<(24-_b%32);
x[((_b+64>>9)<<4)+15]=_b;
var w=Array(80);
var a=1732584193;
var b=-271733879;
var c=-1732584194;
var d=271733878;
var e=-1009589776;
for(var i=0;i<x.length;i+=16){
var _13=a;
var _14=b;
var _15=c;
var _16=d;
var _17=e;
for(var j=0;j<80;j++){
if(j<16){
w[j]=x[i+j];
}else{
w[j]=this.rol(w[j-3]^w[j-8]^w[j-14]^w[j-16],1);
}
var t=this.safe_add(this.safe_add(this.rol(a,5),this.sha1_ft(j,b,c,d)),this.safe_add(this.safe_add(e,w[j]),this.sha1_kt(j)));
e=d;
d=c;
c=this.rol(b,30);
b=a;
a=t;
}
a=this.safe_add(a,_13);
b=this.safe_add(b,_14);
c=this.safe_add(c,_15);
d=this.safe_add(d,_16);
e=this.safe_add(e,_17);
}
return Array(a,b,c,d,e);
},sha1_ft:function(t,b,c,d){
if(t<20){
return (b&c)|((~b)&d);
}
if(t<40){
return b^c^d;
}
if(t<60){
return (b&c)|(b&d)|(c&d);
}
return b^c^d;
},sha1_kt:function(t){
return (t<20)?1518500249:(t<40)?1859775393:(t<60)?-1894007588:-899497514;
},core_hmac_sha1:function(key,_20){
var _21=this.str2binb(key);
if(_21.length>16){
_21=this.core_sha1(_21,key.length*this.chrsz);
}
var _22=Array(16),_23=Array(16);
for(var i=0;i<16;i++){
_22[i]=_21[i]^909522486;
_23[i]=_21[i]^1549556828;
}
var _25=this.core_sha1(_22.concat(this.str2binb(_20)),512+_20.length*this.chrsz);
return this.core_sha1(_23.concat(_25),512+160);
},safe_add:function(x,y){
var lsw=(x&65535)+(y&65535);
var msw=(x>>16)+(y>>16)+(lsw>>16);
return (msw<<16)|(lsw&65535);
},rol:function(num,cnt){
return (num<<cnt)|(num>>>(32-cnt));
},str2binb:function(str){
var bin=Array();
var _2e=(1<<this.chrsz)-1;
for(var i=0;i<str.length*this.chrsz;i+=this.chrsz){
bin[i>>5]|=(str.charCodeAt(i/this.chrsz)&_2e)<<(32-this.chrsz-i%32);
}
return bin;
},binb2str:function(bin){
var str="";
var _32=(1<<this.chrsz)-1;
for(var i=0;i<bin.length*32;i+=this.chrsz){
str+=String.fromCharCode((bin[i>>5]>>>(32-this.chrsz-i%32))&_32);
}
return str;
},binb2hex:function(_34){
var _35=this.hexcase?"0123456789ABCDEF":"0123456789abcdef";
var str="";
for(var i=0;i<_34.length*4;i++){
str+=_35.charAt((_34[i>>2]>>((3-i%4)*8+4))&15)+_35.charAt((_34[i>>2]>>((3-i%4)*8))&15);
}
return str;
},binb2b64:function(_38){
var tab="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
var str="";
for(var i=0;i<_38.length*4;i+=3){
var _3c=(((_38[i>>2]>>8*(3-i%4))&255)<<16)|(((_38[i+1>>2]>>8*(3-(i+1)%4))&255)<<8)|((_38[i+2>>2]>>8*(3-(i+2)%4))&255);
for(var j=0;j<4;j++){
if(i*8+j*6>_38.length*32){
str+=this.b64pad;
}else{
str+=tab.charAt((_3c>>6*(3-j))&63);
}
}
}
return str;
}};

