function s3_TaskDelete(_1,_2){
this.inheritProperties(s3_Task);
this.eventManager.registerEvents(["Abort","DeleteComplete","DeleteFailed"]);
this.hasErrors=false;
this.updateView=_1;
this.authInfo=_2;
}
s3_TaskDelete.prototype={abort:function(){
if(this.currentItem!=null){
this.currentItem.actionInstance.abortRequest();
}
this.eventManager.fireEvent("Abort",null);
this.isAborted=true;
},addToDelete:function(_3,_4){
var _5=_4||{filesFetched:false};
var _6;
var _7=_3.filePath;
if(_3.isDirectory){
var _8=_3.filePath.indexOf("/",1);
if(_8==-1){
_5["type"]="bucket";
_6=3;
}else{
if(_3.eTag!="d66759af42f282e1ba19144df2d405d0"){
_7+="_$folder$";
_5["type"]="folder";
_6=2;
}
}
}else{
_5["filesFetched"]=true;
_5["type"]="file";
_6=1;
}
var _9=new s3_QItem(_7,this.authInfo,_6,_5);
this.processItems.push(_9);
},startProcessing:function(){
this.processItems.sort(this.sortPriority);
this.indexDirty=true;
this.processDelete();
this.addTask("Deleting started...","");
},processDelete:function(){
var _a=this.getNextIndex();
if(_a>=this.processItems.length){
if(this.currentItem!=null){
if(this.hasErrors){
this.setTaskError();
this.eventManager.fireEvent("DeleteFailed",[this]);
}else{
this.removeTask();
this.eventManager.fireEvent("DeleteComplete",[this]);
}
delete this.currentItem;
this.currentItem=null;
}
return;
}
this.currentItem=this.processItems[_a];
try{
this.doDelete(this.currentItem);
}
catch(ex){
this.eventManager.fireEvent("DeleteFailed",[this,ex]);
}
},doDelete:function(_b){
var _c=this;
if(_b.properties["type"]!="file"){
if(!_b.properties["filesFetched"]){
var _d=_b.key;
_d=_d.replace("_$folder$","");
var _e=this.getActionInstance(_b.authInfo,function(){
if(_e.hasErrors){
s3_logView.log(_e.errorMessage,"CustomError");
this.setTaskError();
this.eventManager.fireEvent("DeleteFailed",[this,"Preparing to delete failed"]);
return;
}
_b.status=s3_progStatus.INIT;
_b.properties["filesFetched"]=true;
for(var k=0;k<_e.arrFiles.length;k++){
if(_e.arrFiles[k].filePath!=_d){
this.addToDelete(_e.arrFiles[k],{filesFetched:true});
}
}
this.processItems.sort(this.sortPriority);
this.indexDirty=true;
s3_logView.log("Preparing to delete done... ","message");
this.processDelete();
});
if(_b.properties["type"]=="bucket"){
_d+="/";
}
_b.status=s3_progStatus.PROGRESS;
_e.listAllFiles(_d,true,null);
_b.actionInstance=_e;
this.updateTask("Preparing to delete...");
s3_logView.log("Preparing to delete started... ","message");
return;
}
}
var _e=this.getActionInstance(_b.authInfo,function(_10){
if(_10){
_b.status=s3_progStatus.COMPLETED;
s3_logView.log("Deleting successful - "+_b.key,"message");
}else{
_b.status=s3_progStatus.FAILED;
this.hasErrors=true;
s3_logView.log("Deleting failed - "+_b.key+", "+_e.errorMessage,"CustomError");
}
setTimeout(function(){
_c.processDelete();
},200);
});
_b.status=s3_progStatus.PROGRESS;
_e.deleteFile(_b.key);
_b.actionInstance=_e;
this.updateTask("Deleting "+_b.key);
s3_logView.log("Deleting started - "+_b.key,"message");
}};
s3_extend(s3_TaskDelete,s3_Task);

